/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* First part of user prologue.  */
#line 1 "parser_yacc.y"

/*
 *   Copyright (c) 1999, 2000, 2001, 2002, 2003, 2004, 2005, 2006, 2007
 *   NOVELL (All rights reserved)
 *   Copyright (c) 2010-2012
 *   Canonical Ltd.
 *
 *   This program is free software; you can redistribute it and/or
 *   modify it under the terms of version 2 of the GNU General Public
 *   License published by the Free Software Foundation.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, contact Canonical, Ltd.
 */

#define YYERROR_VERBOSE 1
#include <stdio.h>
#include <stdarg.h>
#include <string.h>
#include <stdlib.h>
#include <getopt.h>
#include <errno.h>
#include <fcntl.h>
#include <sys/apparmor.h>

#include <iostream>

/* #define DEBUG */

#include "capability.h"
#include "lib.h"
#include "parser.h"
#include "profile.h"
#include "mount.h"
#include "dbus.h"
#include "af_unix.h"
#include "parser_include.h"
#include <unistd.h>
#include <netinet/in.h>
#include <arpa/inet.h>


#define CIDR_32 htonl(0xffffffff)
#define CIDR_24 htonl(0xffffff00)
#define CIDR_16 htonl(0xffff0000)
#define CIDR_8  htonl(0xff000000)

/* undefine linux/capability.h CAP_TO_MASK */
#ifdef CAP_TO_MASK
#undef CAP_TO_MASK
#endif

#define CAP_TO_MASK(x) (1ull << (x))

#define EXEC_MODE_EMPTY		0
#define EXEC_MODE_UNSAFE	1
#define EXEC_MODE_SAFE		2

int parser_token = 0;

struct cod_entry *do_file_rule(char *id, perms_t perms, char *link_id, char *nt);
mnt_rule *do_mnt_rule(struct cond_entry *src_conds, char *src,
		      struct cond_entry *dst_conds, char *dst,
		      perms_t perms);
mnt_rule *do_pivot_rule(struct cond_entry *old, char *root,
			char *transition);
static void abi_features(char *filename, bool search);
bool add_prefix(struct cod_entry *entry, const prefixes &p, const char *&error);
bool check_x_qualifier(struct cod_entry *entry, const char *&errror);


#line 148 "parser_yacc.c"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser_yacc.h"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_ID = 3,                     /* TOK_ID  */
  YYSYMBOL_TOK_CONDID = 4,                 /* TOK_CONDID  */
  YYSYMBOL_TOK_CONDLISTID = 5,             /* TOK_CONDLISTID  */
  YYSYMBOL_TOK_CARET = 6,                  /* TOK_CARET  */
  YYSYMBOL_TOK_OPEN = 7,                   /* TOK_OPEN  */
  YYSYMBOL_TOK_CLOSE = 8,                  /* TOK_CLOSE  */
  YYSYMBOL_TOK_MODE = 9,                   /* TOK_MODE  */
  YYSYMBOL_TOK_END_OF_RULE = 10,           /* TOK_END_OF_RULE  */
  YYSYMBOL_TOK_EQUALS = 11,                /* TOK_EQUALS  */
  YYSYMBOL_TOK_ARROW = 12,                 /* TOK_ARROW  */
  YYSYMBOL_TOK_ADD_ASSIGN = 13,            /* TOK_ADD_ASSIGN  */
  YYSYMBOL_TOK_LE = 14,                    /* TOK_LE  */
  YYSYMBOL_TOK_SET_VAR = 15,               /* TOK_SET_VAR  */
  YYSYMBOL_TOK_BOOL_VAR = 16,              /* TOK_BOOL_VAR  */
  YYSYMBOL_TOK_VALUE = 17,                 /* TOK_VALUE  */
  YYSYMBOL_TOK_IF = 18,                    /* TOK_IF  */
  YYSYMBOL_TOK_ELSE = 19,                  /* TOK_ELSE  */
  YYSYMBOL_TOK_NOT = 20,                   /* TOK_NOT  */
  YYSYMBOL_TOK_DEFINED = 21,               /* TOK_DEFINED  */
  YYSYMBOL_TOK_CHANGE_PROFILE = 22,        /* TOK_CHANGE_PROFILE  */
  YYSYMBOL_TOK_NETWORK = 23,               /* TOK_NETWORK  */
  YYSYMBOL_TOK_UNIX = 24,                  /* TOK_UNIX  */
  YYSYMBOL_TOK_CREATE = 25,                /* TOK_CREATE  */
  YYSYMBOL_TOK_SHUTDOWN = 26,              /* TOK_SHUTDOWN  */
  YYSYMBOL_TOK_ACCEPT = 27,                /* TOK_ACCEPT  */
  YYSYMBOL_TOK_CONNECT = 28,               /* TOK_CONNECT  */
  YYSYMBOL_TOK_LISTEN = 29,                /* TOK_LISTEN  */
  YYSYMBOL_TOK_SETOPT = 30,                /* TOK_SETOPT  */
  YYSYMBOL_TOK_GETOPT = 31,                /* TOK_GETOPT  */
  YYSYMBOL_TOK_SETATTR = 32,               /* TOK_SETATTR  */
  YYSYMBOL_TOK_GETATTR = 33,               /* TOK_GETATTR  */
  YYSYMBOL_TOK_HAT = 34,                   /* TOK_HAT  */
  YYSYMBOL_TOK_UNSAFE = 35,                /* TOK_UNSAFE  */
  YYSYMBOL_TOK_SAFE = 36,                  /* TOK_SAFE  */
  YYSYMBOL_TOK_COLON = 37,                 /* TOK_COLON  */
  YYSYMBOL_TOK_LINK = 38,                  /* TOK_LINK  */
  YYSYMBOL_TOK_OWNER = 39,                 /* TOK_OWNER  */
  YYSYMBOL_TOK_OTHER = 40,                 /* TOK_OTHER  */
  YYSYMBOL_TOK_SUBSET = 41,                /* TOK_SUBSET  */
  YYSYMBOL_TOK_AUDIT = 42,                 /* TOK_AUDIT  */
  YYSYMBOL_TOK_DENY = 43,                  /* TOK_DENY  */
  YYSYMBOL_TOK_ALLOW = 44,                 /* TOK_ALLOW  */
  YYSYMBOL_TOK_PROFILE = 45,               /* TOK_PROFILE  */
  YYSYMBOL_TOK_SET = 46,                   /* TOK_SET  */
  YYSYMBOL_TOK_ALIAS = 47,                 /* TOK_ALIAS  */
  YYSYMBOL_TOK_PTRACE = 48,                /* TOK_PTRACE  */
  YYSYMBOL_TOK_OPENPAREN = 49,             /* TOK_OPENPAREN  */
  YYSYMBOL_TOK_CLOSEPAREN = 50,            /* TOK_CLOSEPAREN  */
  YYSYMBOL_TOK_COMMA = 51,                 /* TOK_COMMA  */
  YYSYMBOL_TOK_FILE = 52,                  /* TOK_FILE  */
  YYSYMBOL_TOK_MOUNT = 53,                 /* TOK_MOUNT  */
  YYSYMBOL_TOK_REMOUNT = 54,               /* TOK_REMOUNT  */
  YYSYMBOL_TOK_UMOUNT = 55,                /* TOK_UMOUNT  */
  YYSYMBOL_TOK_PIVOTROOT = 56,             /* TOK_PIVOTROOT  */
  YYSYMBOL_TOK_IN = 57,                    /* TOK_IN  */
  YYSYMBOL_TOK_DBUS = 58,                  /* TOK_DBUS  */
  YYSYMBOL_TOK_SIGNAL = 59,                /* TOK_SIGNAL  */
  YYSYMBOL_TOK_SEND = 60,                  /* TOK_SEND  */
  YYSYMBOL_TOK_RECEIVE = 61,               /* TOK_RECEIVE  */
  YYSYMBOL_TOK_BIND = 62,                  /* TOK_BIND  */
  YYSYMBOL_TOK_READ = 63,                  /* TOK_READ  */
  YYSYMBOL_TOK_WRITE = 64,                 /* TOK_WRITE  */
  YYSYMBOL_TOK_EAVESDROP = 65,             /* TOK_EAVESDROP  */
  YYSYMBOL_TOK_PEER = 66,                  /* TOK_PEER  */
  YYSYMBOL_TOK_TRACE = 67,                 /* TOK_TRACE  */
  YYSYMBOL_TOK_TRACEDBY = 68,              /* TOK_TRACEDBY  */
  YYSYMBOL_TOK_READBY = 69,                /* TOK_READBY  */
  YYSYMBOL_TOK_ABI = 70,                   /* TOK_ABI  */
  YYSYMBOL_TOK_USERNS = 71,                /* TOK_USERNS  */
  YYSYMBOL_TOK_MQUEUE = 72,                /* TOK_MQUEUE  */
  YYSYMBOL_TOK_DELETE = 73,                /* TOK_DELETE  */
  YYSYMBOL_TOK_IO_URING = 74,              /* TOK_IO_URING  */
  YYSYMBOL_TOK_OVERRIDE_CREDS = 75,        /* TOK_OVERRIDE_CREDS  */
  YYSYMBOL_TOK_SQPOLL = 76,                /* TOK_SQPOLL  */
  YYSYMBOL_TOK_RLIMIT = 77,                /* TOK_RLIMIT  */
  YYSYMBOL_TOK_SOFT_RLIMIT = 78,           /* TOK_SOFT_RLIMIT  */
  YYSYMBOL_TOK_RLIMIT_CPU = 79,            /* TOK_RLIMIT_CPU  */
  YYSYMBOL_TOK_RLIMIT_FSIZE = 80,          /* TOK_RLIMIT_FSIZE  */
  YYSYMBOL_TOK_RLIMIT_DATA = 81,           /* TOK_RLIMIT_DATA  */
  YYSYMBOL_TOK_RLIMIT_STACK = 82,          /* TOK_RLIMIT_STACK  */
  YYSYMBOL_TOK_RLIMIT_CORE = 83,           /* TOK_RLIMIT_CORE  */
  YYSYMBOL_TOK_RLIMIT_RSS = 84,            /* TOK_RLIMIT_RSS  */
  YYSYMBOL_TOK_RLIMIT_NOFILE = 85,         /* TOK_RLIMIT_NOFILE  */
  YYSYMBOL_TOK_RLIMIT_OFILE = 86,          /* TOK_RLIMIT_OFILE  */
  YYSYMBOL_TOK_RLIMIT_AS = 87,             /* TOK_RLIMIT_AS  */
  YYSYMBOL_TOK_RLIMIT_NPROC = 88,          /* TOK_RLIMIT_NPROC  */
  YYSYMBOL_TOK_RLIMIT_MEMLOCK = 89,        /* TOK_RLIMIT_MEMLOCK  */
  YYSYMBOL_TOK_RLIMIT_LOCKS = 90,          /* TOK_RLIMIT_LOCKS  */
  YYSYMBOL_TOK_RLIMIT_SIGPENDING = 91,     /* TOK_RLIMIT_SIGPENDING  */
  YYSYMBOL_TOK_RLIMIT_MSGQUEUE = 92,       /* TOK_RLIMIT_MSGQUEUE  */
  YYSYMBOL_TOK_RLIMIT_NICE = 93,           /* TOK_RLIMIT_NICE  */
  YYSYMBOL_TOK_RLIMIT_RTPRIO = 94,         /* TOK_RLIMIT_RTPRIO  */
  YYSYMBOL_TOK_CAPABILITY = 95,            /* TOK_CAPABILITY  */
  YYSYMBOL_TOK_FLAGS = 96,                 /* TOK_FLAGS  */
  YYSYMBOL_YYACCEPT = 97,                  /* $accept  */
  YYSYMBOL_list = 98,                      /* list  */
  YYSYMBOL_99_1 = 99,                      /* $@1  */
  YYSYMBOL_profilelist = 100,              /* profilelist  */
  YYSYMBOL_opt_profile_flag = 101,         /* opt_profile_flag  */
  YYSYMBOL_opt_id = 102,                   /* opt_id  */
  YYSYMBOL_opt_id_or_var = 103,            /* opt_id_or_var  */
  YYSYMBOL_profile_base = 104,             /* profile_base  */
  YYSYMBOL_105_2 = 105,                    /* @2  */
  YYSYMBOL_profile = 106,                  /* profile  */
  YYSYMBOL_local_profile = 107,            /* local_profile  */
  YYSYMBOL_hat = 108,                      /* hat  */
  YYSYMBOL_preamble = 109,                 /* preamble  */
  YYSYMBOL_alias = 110,                    /* alias  */
  YYSYMBOL_varassign = 111,                /* varassign  */
  YYSYMBOL_valuelist = 112,                /* valuelist  */
  YYSYMBOL_flags = 113,                    /* flags  */
  YYSYMBOL_opt_flags = 114,                /* opt_flags  */
  YYSYMBOL_flagvals = 115,                 /* flagvals  */
  YYSYMBOL_flagval = 116,                  /* flagval  */
  YYSYMBOL_opt_subset_flag = 117,          /* opt_subset_flag  */
  YYSYMBOL_opt_audit_flag = 118,           /* opt_audit_flag  */
  YYSYMBOL_opt_owner_flag = 119,           /* opt_owner_flag  */
  YYSYMBOL_opt_rule_mode = 120,            /* opt_rule_mode  */
  YYSYMBOL_opt_prefix = 121,               /* opt_prefix  */
  YYSYMBOL_rules = 122,                    /* rules  */
  YYSYMBOL_block = 123,                    /* block  */
  YYSYMBOL_prefix_rule = 124,              /* prefix_rule  */
  YYSYMBOL_cond_rule = 125,                /* cond_rule  */
  YYSYMBOL_expr = 126,                     /* expr  */
  YYSYMBOL_id_or_var = 127,                /* id_or_var  */
  YYSYMBOL_opt_target = 128,               /* opt_target  */
  YYSYMBOL_opt_named_transition = 129,     /* opt_named_transition  */
  YYSYMBOL_rule = 130,                     /* rule  */
  YYSYMBOL_abi_rule = 131,                 /* abi_rule  */
  YYSYMBOL_opt_exec_mode = 132,            /* opt_exec_mode  */
  YYSYMBOL_opt_file = 133,                 /* opt_file  */
  YYSYMBOL_frule = 134,                    /* frule  */
  YYSYMBOL_file_rule = 135,                /* file_rule  */
  YYSYMBOL_file_rule_tail = 136,           /* file_rule_tail  */
  YYSYMBOL_link_rule = 137,                /* link_rule  */
  YYSYMBOL_network_rule = 138,             /* network_rule  */
  YYSYMBOL_cond = 139,                     /* cond  */
  YYSYMBOL_opt_conds = 140,                /* opt_conds  */
  YYSYMBOL_cond_list = 141,                /* cond_list  */
  YYSYMBOL_opt_cond_list = 142,            /* opt_cond_list  */
  YYSYMBOL_mnt_rule = 143,                 /* mnt_rule  */
  YYSYMBOL_dbus_perm = 144,                /* dbus_perm  */
  YYSYMBOL_dbus_perms = 145,               /* dbus_perms  */
  YYSYMBOL_opt_dbus_perm = 146,            /* opt_dbus_perm  */
  YYSYMBOL_dbus_rule = 147,                /* dbus_rule  */
  YYSYMBOL_net_perm = 148,                 /* net_perm  */
  YYSYMBOL_net_perms = 149,                /* net_perms  */
  YYSYMBOL_opt_net_perm = 150,             /* opt_net_perm  */
  YYSYMBOL_unix_rule = 151,                /* unix_rule  */
  YYSYMBOL_signal_perm = 152,              /* signal_perm  */
  YYSYMBOL_signal_perms = 153,             /* signal_perms  */
  YYSYMBOL_opt_signal_perm = 154,          /* opt_signal_perm  */
  YYSYMBOL_signal_rule = 155,              /* signal_rule  */
  YYSYMBOL_ptrace_perm = 156,              /* ptrace_perm  */
  YYSYMBOL_ptrace_perms = 157,             /* ptrace_perms  */
  YYSYMBOL_opt_ptrace_perm = 158,          /* opt_ptrace_perm  */
  YYSYMBOL_ptrace_rule = 159,              /* ptrace_rule  */
  YYSYMBOL_userns_perm = 160,              /* userns_perm  */
  YYSYMBOL_userns_perms = 161,             /* userns_perms  */
  YYSYMBOL_opt_userns_perm = 162,          /* opt_userns_perm  */
  YYSYMBOL_userns_rule = 163,              /* userns_rule  */
  YYSYMBOL_mqueue_perm = 164,              /* mqueue_perm  */
  YYSYMBOL_mqueue_perms = 165,             /* mqueue_perms  */
  YYSYMBOL_opt_mqueue_perm = 166,          /* opt_mqueue_perm  */
  YYSYMBOL_mqueue_rule = 167,              /* mqueue_rule  */
  YYSYMBOL_io_uring_perm = 168,            /* io_uring_perm  */
  YYSYMBOL_io_uring_perms = 169,           /* io_uring_perms  */
  YYSYMBOL_opt_io_uring_perm = 170,        /* opt_io_uring_perm  */
  YYSYMBOL_io_uring_rule = 171,            /* io_uring_rule  */
  YYSYMBOL_hat_start = 172,                /* hat_start  */
  YYSYMBOL_file_perms = 173,               /* file_perms  */
  YYSYMBOL_change_profile = 174,           /* change_profile  */
  YYSYMBOL_capability = 175,               /* capability  */
  YYSYMBOL_caps = 176                      /* caps  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int16 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   385

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  97
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  80
/* YYNRULES -- Number of rules.  */
#define YYNRULES  221
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  329

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   351


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   309,   309,   308,   336,   338,   344,   345,   346,   348,
     349,   351,   352,   355,   354,   422,   442,   452,   468,   469,
     470,   471,   473,   481,   508,   536,   556,   566,   577,   583,
     584,   592,   597,   623,   628,   667,   668,   669,   671,   672,
     674,   675,   676,   678,   679,   680,   682,   689,   698,   700,
     714,   719,   743,   793,   794,   795,   796,   797,   798,   799,
     800,   802,   811,   831,   850,   859,   868,   874,   973,   985,
     999,  1013,  1018,  1033,  1043,  1053,  1054,  1056,  1057,  1059,
    1060,  1065,  1066,  1068,  1074,  1081,  1082,  1083,  1085,  1086,
    1088,  1093,  1111,  1122,  1125,  1140,  1149,  1159,  1174,  1187,
    1198,  1207,  1221,  1231,  1240,  1241,  1247,  1253,  1254,  1256,
    1261,  1266,  1271,  1276,  1281,  1299,  1300,  1301,  1302,  1303,
    1304,  1305,  1311,  1312,  1313,  1315,  1316,  1317,  1319,  1335,
    1369,  1370,  1371,  1372,  1373,  1374,  1375,  1376,  1377,  1378,
    1379,  1380,  1381,  1382,  1383,  1389,  1390,  1391,  1393,  1394,
    1395,  1397,  1413,  1427,  1428,  1429,  1430,  1431,  1437,  1438,
    1439,  1441,  1442,  1443,  1445,  1451,  1469,  1470,  1471,  1472,
    1473,  1474,  1480,  1481,  1482,  1484,  1485,  1486,  1488,  1494,
    1504,  1506,  1507,  1508,  1510,  1511,  1512,  1514,  1520,  1544,
    1545,  1546,  1547,  1548,  1549,  1550,  1551,  1557,  1558,  1559,
    1561,  1562,  1563,  1565,  1570,  1576,  1588,  1589,  1591,  1592,
    1593,  1595,  1596,  1597,  1599,  1608,  1609,  1611,  1619,  1665,
    1674,  1675
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_ID", "TOK_CONDID",
  "TOK_CONDLISTID", "TOK_CARET", "TOK_OPEN", "TOK_CLOSE", "TOK_MODE",
  "TOK_END_OF_RULE", "TOK_EQUALS", "TOK_ARROW", "TOK_ADD_ASSIGN", "TOK_LE",
  "TOK_SET_VAR", "TOK_BOOL_VAR", "TOK_VALUE", "TOK_IF", "TOK_ELSE",
  "TOK_NOT", "TOK_DEFINED", "TOK_CHANGE_PROFILE", "TOK_NETWORK",
  "TOK_UNIX", "TOK_CREATE", "TOK_SHUTDOWN", "TOK_ACCEPT", "TOK_CONNECT",
  "TOK_LISTEN", "TOK_SETOPT", "TOK_GETOPT", "TOK_SETATTR", "TOK_GETATTR",
  "TOK_HAT", "TOK_UNSAFE", "TOK_SAFE", "TOK_COLON", "TOK_LINK",
  "TOK_OWNER", "TOK_OTHER", "TOK_SUBSET", "TOK_AUDIT", "TOK_DENY",
  "TOK_ALLOW", "TOK_PROFILE", "TOK_SET", "TOK_ALIAS", "TOK_PTRACE",
  "TOK_OPENPAREN", "TOK_CLOSEPAREN", "TOK_COMMA", "TOK_FILE", "TOK_MOUNT",
  "TOK_REMOUNT", "TOK_UMOUNT", "TOK_PIVOTROOT", "TOK_IN", "TOK_DBUS",
  "TOK_SIGNAL", "TOK_SEND", "TOK_RECEIVE", "TOK_BIND", "TOK_READ",
  "TOK_WRITE", "TOK_EAVESDROP", "TOK_PEER", "TOK_TRACE", "TOK_TRACEDBY",
  "TOK_READBY", "TOK_ABI", "TOK_USERNS", "TOK_MQUEUE", "TOK_DELETE",
  "TOK_IO_URING", "TOK_OVERRIDE_CREDS", "TOK_SQPOLL", "TOK_RLIMIT",
  "TOK_SOFT_RLIMIT", "TOK_RLIMIT_CPU", "TOK_RLIMIT_FSIZE",
  "TOK_RLIMIT_DATA", "TOK_RLIMIT_STACK", "TOK_RLIMIT_CORE",
  "TOK_RLIMIT_RSS", "TOK_RLIMIT_NOFILE", "TOK_RLIMIT_OFILE",
  "TOK_RLIMIT_AS", "TOK_RLIMIT_NPROC", "TOK_RLIMIT_MEMLOCK",
  "TOK_RLIMIT_LOCKS", "TOK_RLIMIT_SIGPENDING", "TOK_RLIMIT_MSGQUEUE",
  "TOK_RLIMIT_NICE", "TOK_RLIMIT_RTPRIO", "TOK_CAPABILITY", "TOK_FLAGS",
  "$accept", "list", "$@1", "profilelist", "opt_profile_flag", "opt_id",
  "opt_id_or_var", "profile_base", "@2", "profile", "local_profile", "hat",
  "preamble", "alias", "varassign", "valuelist", "flags", "opt_flags",
  "flagvals", "flagval", "opt_subset_flag", "opt_audit_flag",
  "opt_owner_flag", "opt_rule_mode", "opt_prefix", "rules", "block",
  "prefix_rule", "cond_rule", "expr", "id_or_var", "opt_target",
  "opt_named_transition", "rule", "abi_rule", "opt_exec_mode", "opt_file",
  "frule", "file_rule", "file_rule_tail", "link_rule", "network_rule",
  "cond", "opt_conds", "cond_list", "opt_cond_list", "mnt_rule",
  "dbus_perm", "dbus_perms", "opt_dbus_perm", "dbus_rule", "net_perm",
  "net_perms", "opt_net_perm", "unix_rule", "signal_perm", "signal_perms",
  "opt_signal_perm", "signal_rule", "ptrace_perm", "ptrace_perms",
  "opt_ptrace_perm", "ptrace_rule", "userns_perm", "userns_perms",
  "opt_userns_perm", "userns_rule", "mqueue_perm", "mqueue_perms",
  "opt_mqueue_perm", "mqueue_rule", "io_uring_perm", "io_uring_perms",
  "opt_io_uring_perm", "io_uring_rule", "hat_start", "file_perms",
  "change_profile", "capability", "caps", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-281)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-30)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -281,    33,    -4,  -281,   143,   189,    86,    22,  -281,  -281,
    -281,  -281,    21,    21,   204,   211,   235,   244,    11,  -281,
     260,   260,  -281,   254,  -281,  -281,  -281,  -281,  -281,   298,
    -281,  -281,  -281,   293,   236,  -281,  -281,  -281,  -281,   321,
    -281,   314,  -281,    23,   278,   317,   322,   281,  -281,  -281,
    -281,   315,    14,  -281,  -281,    -2,  -281,    35,  -281,  -281,
     121,  -281,  -281,    91,   282,  -281,   279,  -281,   298,   256,
    -281,  -281,    69,    -1,  -281,  -281,   298,  -281,    21,    21,
    -281,   279,   228,   327,  -281,   334,  -281,  -281,   239,  -281,
     240,   215,   255,    95,   115,   328,  -281,  -281,  -281,  -281,
     141,   305,   203,    52,    27,  -281,  -281,  -281,  -281,   240,
    -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,
    -281,  -281,  -281,  -281,    78,   109,  -281,  -281,  -281,   331,
     325,  -281,  -281,  -281,   127,  -281,  -281,   344,   243,  -281,
    -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,
    -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,
    -281,   236,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,
    -281,  -281,  -281,   289,   289,   289,   289,  -281,  -281,  -281,
    -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,
    -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,
    -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,
    -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,
     288,   171,  -281,  -281,  -281,    13,   335,  -281,  -281,   339,
     343,  -281,   205,   316,   345,   125,    25,   175,   346,   348,
     347,   148,   316,   285,   238,   199,   286,    17,   237,   120,
     316,  -281,  -281,  -281,   351,  -281,    95,  -281,  -281,   344,
     236,   352,  -281,  -281,   280,  -281,   353,   236,  -281,    19,
    -281,  -281,  -281,  -281,  -281,  -281,   236,   354,  -281,   198,
    -281,   357,  -281,   210,  -281,  -281,  -281,    15,  -281,  -281,
    -281,    89,  -281,   360,  -281,  -281,    43,  -281,   361,   214,
     236,   362,  -281,  -281,  -281,  -281,   363,  -281,   320,  -281,
    -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,  -281,
     364,   339,  -281,  -281,   365,  -281,   366,  -281,  -281
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint8 yydefact[] =
{
      18,     0,     2,     1,     0,     0,     0,     0,     4,    19,
      20,    21,     0,     0,     0,     0,     0,     0,     3,    26,
      23,    24,    25,     0,    83,    84,   215,   216,     7,     0,
       5,     8,    27,     0,    11,    15,    22,    75,    76,   107,
      12,     0,   108,    28,     0,     0,     0,     0,   104,    30,
      13,     0,     0,    47,    34,     0,    33,   100,   106,   105,
      38,    31,    32,     0,     0,    14,     0,    39,     0,     0,
      65,    64,    43,    88,    66,    48,     0,   101,     0,     0,
      72,     0,     0,     0,    16,     0,    45,    44,    40,    47,
      85,     0,   148,    35,   175,    89,   104,   104,   104,   104,
     125,   161,   184,   200,   211,   220,    51,    61,    49,    85,
      81,    82,    52,    53,    54,    57,    55,    56,    58,    59,
      60,    62,    63,    17,     0,     0,    71,    73,    74,    68,
       0,    41,    42,    46,    38,    86,    87,     9,     0,    97,
     144,   129,   130,   135,   133,   134,   132,   139,   138,   137,
     136,   145,   140,   141,   131,   142,   143,   149,   104,    37,
      36,     0,   171,   165,   172,   168,   169,   166,   167,   170,
     176,   104,    92,     9,     9,     9,     9,   121,   114,   122,
     116,   117,   115,   118,   119,   120,   126,   104,   157,   152,
     158,   153,   154,   155,   156,   162,   104,   179,   180,   181,
     185,   104,   190,   196,   188,   189,   193,   192,   197,   195,
     194,   191,   201,   104,   205,   208,   206,   207,   212,   104,
       0,     0,    93,   102,   103,     0,     0,    50,    10,    79,
       0,    98,     0,   107,     0,     0,     0,     0,     0,     0,
      77,     0,   107,     0,     0,     0,     0,     0,     0,     0,
     107,   221,   219,   217,     0,    94,    35,    69,    70,     9,
       0,     0,    99,   150,     0,   146,     0,     0,   177,     0,
     173,   178,   109,   104,   111,   112,     0,     0,   127,     0,
     123,     0,   163,     0,   159,   164,   186,     0,   182,   187,
     202,     0,   198,     0,   203,   213,     0,   209,     0,    79,
       0,     0,    80,   218,   147,   151,     0,   174,     0,    78,
     113,   124,   128,   160,   183,   199,   204,   210,   214,    95,
       0,    79,    67,    96,     0,    90,     0,   110,    91
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -281,  -281,  -281,  -281,  -281,  -166,  -281,    62,  -281,  -281,
    -281,  -281,  -281,  -281,  -281,     0,  -281,  -281,  -281,   300,
     105,  -281,  -281,  -281,  -281,   290,   -79,  -281,   152,   297,
    -156,  -281,  -280,  -281,   378,   272,  -281,  -281,  -281,  -281,
    -281,  -281,  -281,   -96,  -281,   -82,  -281,  -131,  -281,  -281,
    -281,   -83,  -281,  -281,  -281,  -136,  -281,  -281,  -281,  -138,
    -281,  -281,  -281,  -146,  -281,  -281,  -281,  -217,  -281,  -281,
    -281,  -233,  -281,  -281,  -281,   367,   128,  -281,  -281,  -281
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
       0,     1,     8,    18,    29,   229,    39,    35,    53,    30,
      70,    71,     2,     9,    10,    20,    46,    47,    55,    56,
     161,    72,   133,    88,    73,    60,   106,   107,    74,    83,
      40,   277,   261,   108,    75,   137,   109,   255,   110,   222,
     111,   112,    59,    52,    42,    43,   113,   186,   241,   187,
     114,   157,   232,   158,   115,   195,   243,   196,   116,   170,
     235,   171,   117,   200,   245,   201,   118,   212,   247,   213,
     119,   218,   249,   219,   120,    76,   256,   121,   122,   220
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
     173,   174,   175,   176,   129,   234,    89,   237,   238,   239,
     240,     4,     5,    21,    -6,    54,   297,    26,    57,   320,
      89,    90,    91,    92,   202,    16,   203,    45,   162,    57,
     292,    66,   197,     3,   204,   271,   163,    93,    19,    17,
     198,   326,   205,     6,   214,    27,    63,    94,    61,   206,
     207,    95,    96,    97,    98,    99,    28,   100,   101,   202,
     214,   203,   233,   317,    58,   254,     7,   290,   291,   204,
     102,   103,   -29,   104,   315,   236,   215,   205,   124,   125,
     209,   210,   165,   166,   206,   207,   167,   168,   169,    15,
     211,   242,    64,   301,   105,    32,   202,   270,   203,   288,
     244,   208,   216,   217,   302,   246,   204,   284,    77,   159,
     280,   306,    86,    87,   205,   209,   210,   248,   216,   217,
     309,   206,   207,   250,   162,   211,    32,    26,   223,    65,
      84,   307,   163,    26,   162,   227,   160,   214,   123,    66,
      78,   314,   163,   319,   321,    66,   257,   313,   311,   265,
     177,   266,   209,   210,    12,    27,    13,   177,   178,   224,
     281,    27,   211,    67,   164,   178,    68,    69,   298,    67,
     295,   296,    68,    69,    37,   268,   269,   308,   165,   166,
     253,   304,   167,   168,   169,   272,    38,   273,   165,   166,
     179,     7,   167,   168,   169,   216,   217,     7,   278,   279,
      14,   180,   181,   182,   183,   184,   185,   177,   180,   181,
     182,   183,   184,   185,   140,   178,   197,    37,   138,   188,
     197,    22,   141,    23,   198,   139,   260,   189,   198,    38,
     142,   143,   144,   145,   146,   147,   148,   149,   150,    37,
     293,    57,    57,   127,   128,    24,   230,   294,   285,   286,
     287,    38,   199,   231,    25,   263,   264,    33,   180,   181,
     182,   183,   184,   185,   140,   152,   153,   154,   155,   156,
     191,   192,   141,   193,   194,   135,   136,    32,   131,   132,
     142,   143,   144,   145,   146,   147,   148,   149,   150,   140,
      57,   251,   228,    57,   188,    80,   289,   141,   252,    81,
      82,    34,   189,    36,   151,   142,   143,   144,   145,   146,
     147,   148,   149,   150,   188,   152,   153,   154,   155,   156,
      57,    41,   189,   324,    57,    44,    41,    48,    49,    50,
      51,    79,    54,    85,    89,   282,   283,   130,   172,   226,
     152,   153,   154,   155,   156,   191,   192,   228,   193,   194,
     225,   260,   259,   262,   190,    62,   274,   267,   275,   276,
     253,   300,   303,   305,   310,   191,   192,   312,   193,   194,
     316,   318,   322,   323,   325,   327,   328,   258,   126,   134,
      11,   221,   299,     0,     0,    31
};

static const yytype_int16 yycheck[] =
{
      96,    97,    98,    99,    83,   161,     7,   173,   174,   175,
     176,    15,    16,    13,     3,    17,   249,     6,     4,   299,
       7,    22,    23,    24,     7,     3,     9,     4,     9,     4,
     247,    18,    17,     0,    17,    10,    17,    38,    17,    17,
      25,   321,    25,    47,    17,    34,    11,    48,    50,    32,
      33,    52,    53,    54,    55,    56,    45,    58,    59,     7,
      17,     9,   158,   296,    50,   221,    70,    50,    51,    17,
      71,    72,    49,    74,   291,   171,    49,    25,    78,    79,
      63,    64,    63,    64,    32,    33,    67,    68,    69,     3,
      73,   187,    57,   259,    95,    17,     7,   235,     9,   245,
     196,    49,    75,    76,   260,   201,    17,   243,    17,    14,
     241,   267,    43,    44,    25,    63,    64,   213,    75,    76,
     276,    32,    33,   219,     9,    73,    17,     6,    50,     8,
      68,   269,    17,     6,     9,     8,    41,    17,    76,    18,
      49,   287,    17,   299,   300,    18,   225,   283,   279,   232,
       9,   233,    63,    64,    11,    34,    13,     9,    17,    50,
     242,    34,    73,    42,    49,    17,    45,    46,   250,    42,
      50,    51,    45,    46,     3,    50,    51,   273,    63,    64,
       9,   264,    67,    68,    69,    10,    15,    12,    63,    64,
      49,    70,    67,    68,    69,    75,    76,    70,    50,    51,
      11,    60,    61,    62,    63,    64,    65,     9,    60,    61,
      62,    63,    64,    65,     9,    17,    17,     3,     3,     9,
      17,    17,    17,    12,    25,    10,    12,    17,    25,    15,
      25,    26,    27,    28,    29,    30,    31,    32,    33,     3,
       3,     4,     4,    15,    16,    10,     3,    10,    10,    50,
      51,    15,    49,    10,    10,    50,    51,     3,    60,    61,
      62,    63,    64,    65,     9,    60,    61,    62,    63,    64,
      60,    61,    17,    63,    64,    35,    36,    17,    39,    40,
      25,    26,    27,    28,    29,    30,    31,    32,    33,     9,
       4,     3,     3,     4,     9,    16,    10,    17,    10,    20,
      21,     3,    17,    10,    49,    25,    26,    27,    28,    29,
      30,    31,    32,    33,     9,    60,    61,    62,    63,    64,
       4,     5,    17,     3,     4,    11,     5,    49,    11,     7,
      49,    49,    17,    77,     7,    50,    51,     3,    10,    14,
      60,    61,    62,    63,    64,    60,    61,     3,    63,    64,
      19,    12,    17,    10,    49,    55,    10,    12,    10,    12,
       9,   256,    10,    10,    10,    60,    61,    10,    63,    64,
      10,    10,    10,    10,    10,    10,    10,   225,    81,    89,
       2,   109,   254,    -1,    -1,    18
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,    98,   109,     0,    15,    16,    47,    70,    99,   110,
     111,   131,    11,    13,    11,     3,     3,    17,   100,    17,
     112,   112,    17,    12,    10,    10,     6,    34,    45,   101,
     106,   172,    17,     3,     3,   104,    10,     3,    15,   103,
     127,     5,   141,   142,    11,     4,   113,   114,    49,    11,
       7,    49,   140,   105,    17,   115,   116,     4,    50,   139,
     122,    50,   116,    11,    57,     8,    18,    42,    45,    46,
     107,   108,   118,   121,   125,   131,   172,    17,    49,    49,
      16,    20,    21,   126,   104,    77,    43,    44,   120,     7,
      22,    23,    24,    38,    48,    52,    53,    54,    55,    56,
      58,    59,    71,    72,    74,    95,   123,   124,   130,   133,
     135,   137,   138,   143,   147,   151,   155,   159,   163,   167,
     171,   174,   175,   104,   112,   112,   126,    15,    16,   123,
       3,    39,    40,   119,   122,    35,    36,   132,     3,    10,
       9,    17,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    49,    60,    61,    62,    63,    64,   148,   150,    14,
      41,   117,     9,    17,    49,    63,    64,    67,    68,    69,
     156,   158,    10,   140,   140,   140,   140,     9,    17,    49,
      60,    61,    62,    63,    64,    65,   144,   146,     9,    17,
      49,    60,    61,    63,    64,   152,   154,    17,    25,    49,
     160,   162,     7,     9,    17,    25,    32,    33,    49,    63,
      64,    73,   164,   166,    17,    49,    75,    76,   168,   170,
     176,   132,   136,    50,    50,    19,    14,     8,     3,   102,
       3,    10,   149,   140,   127,   157,   140,   102,   102,   102,
     102,   145,   140,   153,   140,   161,   140,   165,   140,   169,
     140,     3,    10,     9,   127,   134,   173,   123,   125,    17,
      12,   129,    10,    50,    51,   148,   142,    12,    50,    51,
     156,    10,    10,    12,    10,    10,    12,   128,    50,    51,
     144,   142,    50,    51,   152,    10,    50,    51,   160,    10,
      50,    51,   164,     3,    10,    50,    51,   168,   142,   173,
     117,   102,   127,    10,   148,    10,   127,   156,   140,   127,
      10,   144,    10,   152,   160,   164,    10,   168,    10,   127,
     129,   127,    10,    10,     3,    10,   129,    10,    10
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_uint8 yyr1[] =
{
       0,    97,    99,    98,   100,   100,   101,   101,   101,   102,
     102,   103,   103,   105,   104,   106,   107,   108,   109,   109,
     109,   109,   110,   111,   111,   111,   112,   112,   113,   114,
     114,   113,   115,   115,   116,   117,   117,   117,   118,   118,
     119,   119,   119,   120,   120,   120,   121,   122,   122,   122,
     123,   122,   122,   124,   124,   124,   124,   124,   124,   124,
     124,   122,   122,   122,   122,   122,   122,   122,   125,   125,
     125,   126,   126,   126,   126,   127,   127,   128,   128,   129,
     129,   130,   130,   131,   131,   132,   132,   132,   133,   133,
     134,   134,   135,   135,   136,   136,   137,   138,   138,   138,
     139,   139,   139,   139,   140,   140,   141,   142,   142,   143,
     143,   143,   143,   143,   144,   144,   144,   144,   144,   144,
     144,   144,   145,   145,   145,   146,   146,   146,   147,   148,
     148,   148,   148,   148,   148,   148,   148,   148,   148,   148,
     148,   148,   148,   148,   148,   149,   149,   149,   150,   150,
     150,   151,   152,   152,   152,   152,   152,   152,   153,   153,
     153,   154,   154,   154,   155,   156,   156,   156,   156,   156,
     156,   156,   157,   157,   157,   158,   158,   158,   159,   160,
     160,   161,   161,   161,   162,   162,   162,   163,   164,   164,
     164,   164,   164,   164,   164,   164,   164,   165,   165,   165,
     166,   166,   166,   167,   167,   168,   168,   168,   169,   169,
     169,   170,   170,   170,   171,   172,   172,   173,   174,   175,
     176,   176
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     0,     3,     0,     2,     0,     1,     1,     0,
       1,     0,     1,     0,     8,     2,     2,     2,     0,     2,
       2,     2,     5,     3,     3,     3,     1,     2,     0,     0,
       2,     4,     2,     1,     1,     0,     1,     1,     0,     1,
       0,     1,     1,     0,     1,     1,     3,     0,     2,     3,
       3,     3,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     3,     3,     3,     2,     2,     2,     8,     3,     5,
       5,     2,     1,     2,     2,     1,     1,     0,     2,     0,
       2,     1,     1,     3,     3,     0,     1,     1,     0,     1,
       4,     5,     2,     2,     2,     4,     6,     2,     3,     4,
       1,     3,     5,     5,     0,     2,     5,     0,     1,     4,
       7,     4,     4,     5,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     2,     3,     0,     1,     3,     5,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     0,     2,     3,     0,     1,
       3,     5,     1,     1,     1,     1,     1,     1,     0,     2,
       3,     0,     1,     3,     4,     1,     1,     1,     1,     1,
       1,     1,     0,     2,     3,     0,     1,     3,     4,     1,
       1,     0,     2,     3,     0,     1,     3,     4,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     0,     2,     3,
       0,     1,     3,     4,     5,     1,     1,     1,     0,     2,
       3,     0,     1,     3,     5,     1,     1,     1,     5,     3,
       0,     2
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)]);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep)
{
  YY_USE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/* Lookahead token kind.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;




/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* $@1: %empty  */
#line 309 "parser_yacc.y"
        {
		/* make sure abi is setup */
		if (override_features) {
			if (policy_features)
				aa_features_unref(policy_features);
			policy_features = aa_features_ref(override_features);
		} else if (policy_features == NULL) {
			if (pinned_features) {
				policy_features = aa_features_ref(pinned_features);
			/* use default feature abi */
			} else {
				if (aa_features_new_from_string(&policy_features,
								default_features_abi,
								strlen(default_features_abi))) {
					yyerror(_("Failed to setup default policy feature abi"));
				}
				pwarn(WARN_ABI, _("%s: File '%s' missing feature abi, falling back to default policy feature abi\n"), progname, current_filename);
			}
		}
		if (!add_cap_feature_mask(policy_features,
					  CAPFLAG_POLICY_FEATURE))
			yyerror(_("Failed to add policy capabilities to known capabilities set"));
		set_supported_features();

	}
#line 1890 "parser_yacc.c"
    break;

  case 4: /* profilelist: %empty  */
#line 336 "parser_yacc.y"
                { /* nothing */ }
#line 1896 "parser_yacc.c"
    break;

  case 5: /* profilelist: profilelist profile  */
#line 339 "parser_yacc.y"
        {
		PDEBUG("Matched: list profile\n");
		add_to_list((yyvsp[0].prof));
	}
#line 1905 "parser_yacc.c"
    break;

  case 6: /* opt_profile_flag: %empty  */
#line 344 "parser_yacc.y"
                  { /* nothing */ (yyval.boolean) = 0; }
#line 1911 "parser_yacc.c"
    break;

  case 7: /* opt_profile_flag: TOK_PROFILE  */
#line 345 "parser_yacc.y"
                      { (yyval.boolean) = 1; }
#line 1917 "parser_yacc.c"
    break;

  case 8: /* opt_profile_flag: hat_start  */
#line 346 "parser_yacc.y"
                    { (yyval.boolean) = 2; }
#line 1923 "parser_yacc.c"
    break;

  case 9: /* opt_id: %empty  */
#line 348 "parser_yacc.y"
        { /* nothing */ (yyval.id) = NULL; }
#line 1929 "parser_yacc.c"
    break;

  case 10: /* opt_id: TOK_ID  */
#line 349 "parser_yacc.y"
                 { (yyval.id) = (yyvsp[0].id); }
#line 1935 "parser_yacc.c"
    break;

  case 11: /* opt_id_or_var: %empty  */
#line 351 "parser_yacc.y"
               { /* nothing */ (yyval.id) = NULL; }
#line 1941 "parser_yacc.c"
    break;

  case 12: /* opt_id_or_var: id_or_var  */
#line 352 "parser_yacc.y"
                    { (yyval.id) = (yyvsp[0].id); }
#line 1947 "parser_yacc.c"
    break;

  case 13: /* @2: %empty  */
#line 355 "parser_yacc.y"
        {
		/* mid rule action
		 * save current cache, restore at end of block
		 */
		(yyval.includecache) = g_includecache;
		g_includecache = new IncludeCache_t();
	}
#line 1959 "parser_yacc.c"
    break;

  case 14: /* profile_base: TOK_ID opt_id_or_var opt_cond_list flags TOK_OPEN @2 rules TOK_CLOSE  */
#line 363 "parser_yacc.y"
        {
		Profile *prof = (yyvsp[-1].prof);
		bool self_stack = false;

		if (!prof) {
			yyerror(_("Memory allocation error."));
		}

		parse_label(&self_stack, &prof->ns, &prof->name, (yyvsp[-7].id), true);
		free((yyvsp[-7].id));

		if (self_stack) {
			yyerror(_("Profile names must begin with a '/' or a namespace"));
		}

		/* Honor the --namespace-string command line option */
		if (profile_ns) {
			/**
			 * Print warning if the profile specified a namespace
			 * different than the one specified with the
			 * --namespace-string command line option
			 */
			if (prof->ns && strcmp(prof->ns, profile_ns))
				pwarn(WARN_OVERRIDE, "%s: -n %s overriding policy specified namespace :%s:\n",
				      progname, profile_ns, prof->ns);

			free(prof->ns);
			prof->ns = strdup(profile_ns);
			if (!prof->ns)
				yyerror(_("Memory allocation error."));
		}

		prof->attachment = (yyvsp[-6].id);
		if ((yyvsp[-6].id) && !((yyvsp[-6].id)[0] == '/' || strncmp((yyvsp[-6].id), "@{", 2) == 0))
			yyerror(_("Profile attachment must begin with a '/' or variable."));
		if ((yyvsp[-5].cond_entry_list).name) {
			if (strcmp((yyvsp[-5].cond_entry_list).name, "xattrs") != 0)
				yyerror(_("profile id: invalid conditional group %s=()"), (yyvsp[-5].cond_entry_list).name);
			free ((yyvsp[-5].cond_entry_list).name);
			(yyvsp[-5].cond_entry_list).name = NULL;
			prof->xattrs = (yyvsp[-5].cond_entry_list);
		}
		prof->flags = (yyvsp[-4].flags);
		if (force_complain && kernel_abi_version == 5)
			/* newer abis encode force complain as part of the
			 * header
			 */
			prof->flags.mode = MODE_COMPLAIN;

		prof->post_parse_profile();
		prof->flags.debug(cerr);

		/* restore previous blocks include cache */
		delete g_includecache;
		g_includecache = (yyvsp[-2].includecache);
		(yyval.prof) = prof;

	}
#line 2022 "parser_yacc.c"
    break;

  case 15: /* profile: opt_profile_flag profile_base  */
#line 423 "parser_yacc.y"
        {
		Profile *prof = (yyvsp[0].prof);

		if ((yyvsp[0].prof)->ns)
			PDEBUG("Matched: :%s://%s { ... }\n", (yyvsp[0].prof)->ns, (yyvsp[0].prof)->name);
		else
			PDEBUG("Matched: %s { ... }\n", (yyvsp[0].prof)->name);

		if ((yyvsp[0].prof)->name[0] == '/')
			pwarn(WARN_DEPRECATED, _("The use of file paths as profile names is deprecated. See man apparmor.d for more information\n"));

		if ((yyvsp[0].prof)->name[0] != '/' && !((yyvsp[-1].boolean) || (yyvsp[0].prof)->ns))
			yyerror(_("Profile names must begin with a '/', namespace or keyword 'profile' or 'hat'."));

		if ((yyvsp[-1].boolean) == 2)
			prof->flags.flags |= FLAG_HAT;
		(yyval.prof) = prof;
	}
#line 2045 "parser_yacc.c"
    break;

  case 16: /* local_profile: TOK_PROFILE profile_base  */
#line 443 "parser_yacc.y"
        {

		Profile *prof = (yyvsp[0].prof);

		if ((yyvsp[0].prof))
			PDEBUG("Matched: local profile %s { ... }\n", prof->name);
		(yyval.prof) = prof;
	}
#line 2058 "parser_yacc.c"
    break;

  case 17: /* hat: hat_start profile_base  */
#line 453 "parser_yacc.y"
        {
		Profile *prof = (yyvsp[0].prof);
		if ((yyvsp[0].prof))
			PDEBUG("Matched: hat %s { ... }\n", prof->name);
		/*
		 * It isn't clear what a xattrs match on a hat profile
		 * should do, disallow it for now.
		 */
		if ((yyvsp[0].prof)->xattrs.list)
			yyerror("hat profiles can't use xattrs matches");

		prof->flags.flags |= FLAG_HAT;
		(yyval.prof) = prof;
	}
#line 2077 "parser_yacc.c"
    break;

  case 18: /* preamble: %empty  */
#line 468 "parser_yacc.y"
          { /* nothing */ }
#line 2083 "parser_yacc.c"
    break;

  case 19: /* preamble: preamble alias  */
#line 469 "parser_yacc.y"
                         { /* nothing */ }
#line 2089 "parser_yacc.c"
    break;

  case 20: /* preamble: preamble varassign  */
#line 470 "parser_yacc.y"
                             { /* nothing */ }
#line 2095 "parser_yacc.c"
    break;

  case 21: /* preamble: preamble abi_rule  */
#line 471 "parser_yacc.y"
                            { /* nothing */ }
#line 2101 "parser_yacc.c"
    break;

  case 22: /* alias: TOK_ALIAS TOK_ID TOK_ARROW TOK_ID TOK_END_OF_RULE  */
#line 474 "parser_yacc.y"
        {
		if (!new_alias((yyvsp[-3].id), (yyvsp[-1].id)))
			yyerror(_("Failed to create alias %s -> %s\n"), (yyvsp[-3].id), (yyvsp[-1].id));
		free((yyvsp[-3].id));
		free((yyvsp[-1].id));
	}
#line 2112 "parser_yacc.c"
    break;

  case 23: /* varassign: TOK_SET_VAR TOK_EQUALS valuelist  */
#line 482 "parser_yacc.y"
        {
		struct value_list *list = (yyvsp[0].val_list);
		char *var_name = process_var((yyvsp[-2].set_var));
		int err;
		if (!list || !list->value)
			yyerror("Assert: valuelist returned NULL");
		PDEBUG("Matched: set assignment for (%s)\n", (yyvsp[-2].set_var));
		err = new_set_var(var_name, list->value);
		if (err) {
			free(var_name);
			yyerror("variable %s was previously declared", (yyvsp[-2].set_var));
			/* FIXME: it'd be handy to report the previous location */
		}
		for (list = list->next; list; list = list->next) {
			err = add_set_value(var_name, list->value);
			if (err) {
				free(var_name);
				yyerror("Error adding %s to set var %s",
					list->value, (yyvsp[-2].set_var));
			}
		}
		free_value_list((yyvsp[0].val_list));
		free(var_name);
		free((yyvsp[-2].set_var));
	}
#line 2142 "parser_yacc.c"
    break;

  case 24: /* varassign: TOK_SET_VAR TOK_ADD_ASSIGN valuelist  */
#line 509 "parser_yacc.y"
        {
		struct value_list *list = (yyvsp[0].val_list);
		char *var_name = process_var((yyvsp[-2].set_var));
		int err;
		if (!list || !list->value)
			yyerror("Assert: valuelist returned NULL");
		PDEBUG("Matched: additive assignment for (%s)\n", (yyvsp[-2].set_var));
		/* do the first one outside the loop, subsequent
		 * failures are indicative of symtab failures */
		err = add_set_value(var_name, list->value);
		if (err) {
			free(var_name);
			yyerror("variable %s was not previously declared, but is being assigned additional values", (yyvsp[-2].set_var));
		}
		for (list = list->next; list; list = list->next) {
			err = add_set_value(var_name, list->value);
			if (err) {
				free(var_name);
				yyerror("Error adding %s to set var %s",
					list->value, (yyvsp[-2].set_var));
			}
		}
		free_value_list((yyvsp[0].val_list));
		free(var_name);
		free((yyvsp[-2].set_var));
	}
#line 2173 "parser_yacc.c"
    break;

  case 25: /* varassign: TOK_BOOL_VAR TOK_EQUALS TOK_VALUE  */
#line 537 "parser_yacc.y"
        {
		int boolean, err;
		char *var_name = process_var((yyvsp[-2].bool_var));
		PDEBUG("Matched: boolean assignment (%s) to %s\n", (yyvsp[-2].bool_var), (yyvsp[0].var_val));
		boolean = str_to_boolean((yyvsp[0].var_val));
		if (boolean == -1) {
			yyerror("Invalid boolean assignment for (%s): %s is not true or false",
				(yyvsp[-2].bool_var), (yyvsp[0].var_val));
		}
		err = add_boolean_var(var_name, boolean);
		free(var_name);
		if (err) {
			yyerror("variable %s was previously declared", (yyvsp[-2].bool_var));
			/* FIXME: it'd be handy to report the previous location */
		}
		free((yyvsp[-2].bool_var));
		free((yyvsp[0].var_val));
	}
#line 2196 "parser_yacc.c"
    break;

  case 26: /* valuelist: TOK_VALUE  */
#line 557 "parser_yacc.y"
        {
		struct value_list *val = new_value_list((yyvsp[0].var_val));
		if (!val)
			yyerror(_("Memory allocation error."));
		PDEBUG("Matched: value (%s)\n", (yyvsp[0].var_val));

		(yyval.val_list) = val;
	}
#line 2209 "parser_yacc.c"
    break;

  case 27: /* valuelist: valuelist TOK_VALUE  */
#line 567 "parser_yacc.y"
        {
		struct value_list *val = new_value_list((yyvsp[0].var_val));
		if (!val)
			yyerror(_("Memory allocation error."));
		PDEBUG("Matched: value list\n");

		list_append((yyvsp[-1].val_list), val);
		(yyval.val_list) = (yyvsp[-1].val_list);
	}
#line 2223 "parser_yacc.c"
    break;

  case 28: /* flags: %empty  */
#line 577 "parser_yacc.y"
        { /* nothing */
	flagvals fv = { 0, MODE_UNSPECIFIED, 0, 0, NULL };

		(yyval.flags) = fv;
	}
#line 2233 "parser_yacc.c"
    break;

  case 29: /* opt_flags: %empty  */
#line 583 "parser_yacc.y"
           { /* nothing */ (yyval.boolean) = 0; }
#line 2239 "parser_yacc.c"
    break;

  case 30: /* opt_flags: TOK_CONDID TOK_EQUALS  */
#line 585 "parser_yacc.y"
        {
		if (strcmp((yyvsp[-1].id), "flags") != 0)
			yyerror("expected flags= got %s=", (yyvsp[-1].id));
		free((yyvsp[-1].id));
		(yyval.boolean) = 1;
	}
#line 2250 "parser_yacc.c"
    break;

  case 31: /* flags: opt_flags TOK_OPENPAREN flagvals TOK_CLOSEPAREN  */
#line 593 "parser_yacc.y"
        {
		(yyval.flags) = (yyvsp[-1].flags);
	}
#line 2258 "parser_yacc.c"
    break;

  case 32: /* flagvals: flagvals flagval  */
#line 598 "parser_yacc.y"
        {
		if (merge_profile_mode((yyvsp[-1].flags).mode, (yyvsp[0].flags).mode) == MODE_CONFLICT)
			yyerror(_("Profile flag '%s' conflicts with '%s'"),
				profile_mode_table[(yyvsp[-1].flags).mode],
				profile_mode_table[(yyvsp[0].flags).mode]);
		(yyvsp[-1].flags).mode = merge_profile_mode((yyvsp[-1].flags).mode, (yyvsp[0].flags).mode);
		(yyvsp[-1].flags).audit = (yyvsp[-1].flags).audit || (yyvsp[0].flags).audit;
		(yyvsp[-1].flags).path = (yyvsp[-1].flags).path | (yyvsp[0].flags).path;
		if (((yyvsp[-1].flags).path & (PATH_CHROOT_REL | PATH_NS_REL)) ==
		    (PATH_CHROOT_REL | PATH_NS_REL))
			yyerror(_("Profile flag chroot_relative conflicts with namespace_relative"));

		if (((yyvsp[-1].flags).path & (PATH_MEDIATE_DELETED | PATH_DELEGATE_DELETED)) ==
		    (PATH_MEDIATE_DELETED | PATH_DELEGATE_DELETED))
			yyerror(_("Profile flag mediate_deleted conflicts with delegate_deleted"));
		if (((yyvsp[-1].flags).path & (PATH_ATTACH | PATH_NO_ATTACH)) ==
		    (PATH_ATTACH | PATH_NO_ATTACH))
			yyerror(_("Profile flag attach_disconnected conflicts with no_attach_disconnected"));
		if (((yyvsp[-1].flags).path & (PATH_CHROOT_NSATTACH | PATH_CHROOT_NO_ATTACH)) ==
		    (PATH_CHROOT_NSATTACH | PATH_CHROOT_NO_ATTACH))
			yyerror(_("Profile flag chroot_attach conflicts with chroot_no_attach"));

		(yyval.flags) = (yyvsp[-1].flags);
	}
#line 2287 "parser_yacc.c"
    break;

  case 33: /* flagvals: flagval  */
#line 624 "parser_yacc.y"
        {
		(yyval.flags) = (yyvsp[0].flags);
	}
#line 2295 "parser_yacc.c"
    break;

  case 34: /* flagval: TOK_VALUE  */
#line 629 "parser_yacc.y"
        {
		flagvals fv = { 0, MODE_UNSPECIFIED, 0, 0, NULL };
		enum profile_mode mode;

		if (strcmp((yyvsp[0].var_val), "debug") == 0) {
			/* DEBUG2 is left for internal compiler use atm */
			fv.flags |= FLAG_DEBUG1;
		} else if ((mode = str_to_mode((yyvsp[0].var_val)))) {
			fv.mode = mode;
		} else if (strcmp((yyvsp[0].var_val), "audit") == 0) {
			fv.audit = 1;
		} else if (strcmp((yyvsp[0].var_val), "chroot_relative") == 0) {
			fv.path |= PATH_CHROOT_REL;
		} else if (strcmp((yyvsp[0].var_val), "namespace_relative") == 0) {
			fv.path |= PATH_NS_REL;
		} else if (strcmp((yyvsp[0].var_val), "mediate_deleted") == 0) {
			fv.path |= PATH_MEDIATE_DELETED;
		} else if (strcmp((yyvsp[0].var_val), "delegate_deleted") == 0) {
			fv.path |= PATH_DELEGATE_DELETED;
		} else if (strcmp((yyvsp[0].var_val), "attach_disconnected") == 0) {
			fv.path |= PATH_ATTACH;
		} else if (strcmp((yyvsp[0].var_val), "no_attach_disconnected") == 0) {
			fv.path |= PATH_NO_ATTACH;
		} else if (strcmp((yyvsp[0].var_val), "chroot_attach") == 0) {
			fv.path |= PATH_CHROOT_NSATTACH;
		} else if (strcmp((yyvsp[0].var_val), "chroot_no_attach") == 0) {
			fv.path |= PATH_CHROOT_NO_ATTACH;
		} else if (strncmp((yyvsp[0].var_val), "attach_disconnected.path=", 25) == 0) {
			/* TODO: make this a proper parse */
			fv.path |= PATH_ATTACH;
			fv.disconnected_path = strdup((yyvsp[0].var_val) + 25);
		} else {
			yyerror(_("Invalid profile flag: %s."), (yyvsp[0].var_val));
		}
		free((yyvsp[0].var_val));
		(yyval.flags) = fv;
	}
#line 2337 "parser_yacc.c"
    break;

  case 35: /* opt_subset_flag: %empty  */
#line 667 "parser_yacc.y"
                 { /* nothing */ (yyval.boolean) = false; }
#line 2343 "parser_yacc.c"
    break;

  case 36: /* opt_subset_flag: TOK_SUBSET  */
#line 668 "parser_yacc.y"
                     { (yyval.boolean) = true; }
#line 2349 "parser_yacc.c"
    break;

  case 37: /* opt_subset_flag: TOK_LE  */
#line 669 "parser_yacc.y"
                 { (yyval.boolean) = true; }
#line 2355 "parser_yacc.c"
    break;

  case 38: /* opt_audit_flag: %empty  */
#line 671 "parser_yacc.y"
                { /* nothing */ (yyval.audit) = AUDIT_UNSPECIFIED; }
#line 2361 "parser_yacc.c"
    break;

  case 39: /* opt_audit_flag: TOK_AUDIT  */
#line 672 "parser_yacc.y"
                    { (yyval.audit) = AUDIT_FORCE; }
#line 2367 "parser_yacc.c"
    break;

  case 40: /* opt_owner_flag: %empty  */
#line 674 "parser_yacc.y"
                { /* nothing */ (yyval.boolean) = 0; }
#line 2373 "parser_yacc.c"
    break;

  case 41: /* opt_owner_flag: TOK_OWNER  */
#line 675 "parser_yacc.y"
                    { (yyval.boolean) = 1; }
#line 2379 "parser_yacc.c"
    break;

  case 42: /* opt_owner_flag: TOK_OTHER  */
#line 676 "parser_yacc.y"
                    { (yyval.boolean) = 2; }
#line 2385 "parser_yacc.c"
    break;

  case 43: /* opt_rule_mode: %empty  */
#line 678 "parser_yacc.y"
               { /* nothing */ (yyval.rule_mode) = RULE_UNSPECIFIED; }
#line 2391 "parser_yacc.c"
    break;

  case 44: /* opt_rule_mode: TOK_ALLOW  */
#line 679 "parser_yacc.y"
                    { (yyval.rule_mode) = RULE_ALLOW; }
#line 2397 "parser_yacc.c"
    break;

  case 45: /* opt_rule_mode: TOK_DENY  */
#line 680 "parser_yacc.y"
                   { (yyval.rule_mode) = RULE_DENY; }
#line 2403 "parser_yacc.c"
    break;

  case 46: /* opt_prefix: opt_audit_flag opt_rule_mode opt_owner_flag  */
#line 683 "parser_yacc.y"
        {
		(yyval.prefix).audit = (yyvsp[-2].audit);
		(yyval.prefix).rule_mode = (yyvsp[-1].rule_mode);
		(yyval.prefix).owner = (yyvsp[0].boolean);
	}
#line 2413 "parser_yacc.c"
    break;

  case 47: /* rules: %empty  */
#line 689 "parser_yacc.y"
        { /* nothing */ 
	Profile *prof = new Profile();
		if (!prof) {
			yyerror(_("Memory allocation error."));
		}

		(yyval.prof) = prof;
	}
#line 2426 "parser_yacc.c"
    break;

  case 48: /* rules: rules abi_rule  */
#line 698 "parser_yacc.y"
                      { /* nothing */ }
#line 2432 "parser_yacc.c"
    break;

  case 49: /* rules: rules opt_prefix rule  */
#line 701 "parser_yacc.y"
        {
		const char *error;
		PDEBUG("matched: rules rule\n");
		PDEBUG("rules rule: (%s)\n", (yyvsp[0].user_entry)->name);
		if (!(yyvsp[0].user_entry))
			yyerror(_("Assert: `rule' returned NULL."));
		if (!add_prefix((yyvsp[0].user_entry), (yyvsp[-1].prefix), error)) {
			yyerror(_("%s"), error);
		}
		add_entry_to_policy((yyvsp[-2].prof), (yyvsp[0].user_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2449 "parser_yacc.c"
    break;

  case 50: /* block: TOK_OPEN rules TOK_CLOSE  */
#line 715 "parser_yacc.y"
        {
		(yyval.prof) = (yyvsp[-1].prof);
	}
#line 2457 "parser_yacc.c"
    break;

  case 51: /* rules: rules opt_prefix block  */
#line 720 "parser_yacc.y"
        {
		struct cod_entry *entry, *tmp;

		PDEBUG("matched: %s%s%sblock\n", (yyvsp[-1].prefix).audit == AUDIT_FORCE ? "audit " : "",
		       (yyvsp[-1].prefix).rule_mode == RULE_DENY ? "deny " : "", (yyvsp[-1].prefix).owner ? "owner " : "");
		list_for_each_safe((yyvsp[0].prof)->entries, entry, tmp) {
			const char *error;
			entry->next = NULL;
			if (!add_prefix(entry, (yyvsp[-1].prefix), error)) {
				yyerror(_("%s"), error);
			}
			/* transfer rule for now, TODO keep block and just
			 * apply add_prefix to block rule and have it do
			 * the work
			 */
			add_entry_to_policy((yyvsp[-2].prof), entry);
		}
		(yyvsp[0].prof)->entries = NULL;
		// fix me transfer rules and free sub profile
		delete (yyvsp[0].prof);
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2484 "parser_yacc.c"
    break;

  case 52: /* rules: rules opt_prefix network_rule  */
#line 744 "parser_yacc.y"
        {
		struct aa_network_entry *entry, *tmp;

		PDEBUG("Matched: network rule\n");
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed"));
		if (!(yyvsp[0].network_entry))
			yyerror(_("Assert: `network_rule' return invalid protocol."));
		if (!(yyvsp[-2].prof)->alloc_net_table())
			yyerror(_("Memory allocation error."));
		list_for_each_safe((yyvsp[0].network_entry), entry, tmp) {

			/* map to extended mediation, let rule backend do
			 * downgrade if needed
			 */
			if (entry->family == AF_UNIX) {
				unix_rule *rule = new unix_rule(entry->type, (yyvsp[-1].prefix).audit, (yyvsp[-1].prefix).rule_mode);
				if (!rule)
					yyerror(_("Memory allocation error."));
				(yyvsp[-2].prof)->rule_ents.push_back(rule);
			}
			if (entry->type > SOCK_PACKET) {
				/* setting mask instead of a bit */
				if ((yyvsp[-1].prefix).rule_mode == RULE_DENY) {
					(yyvsp[-2].prof)->net.deny[entry->family] |= entry->type;
					if ((yyvsp[-1].prefix).audit != AUDIT_FORCE)
						(yyvsp[-2].prof)->net.quiet[entry->family] |= entry->type;
				} else {
					(yyvsp[-2].prof)->net.allow[entry->family] |= entry->type;
					if ((yyvsp[-1].prefix).audit == AUDIT_FORCE)
						(yyvsp[-2].prof)->net.audit[entry->family] |= entry->type;
				}
			} else {
				if ((yyvsp[-1].prefix).rule_mode == RULE_DENY) {
					(yyvsp[-2].prof)->net.deny[entry->family] |= 1 << entry->type;
					if ((yyvsp[-1].prefix).audit != AUDIT_FORCE)
						(yyvsp[-2].prof)->net.quiet[entry->family] |= 1 << entry->type;
				} else {
					(yyvsp[-2].prof)->net.allow[entry->family] |= 1 << entry->type;
					if ((yyvsp[-1].prefix).audit == AUDIT_FORCE)
						(yyvsp[-2].prof)->net.audit[entry->family] |= 1 << entry->type;
				}
			}
			free(entry);
		}

		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2537 "parser_yacc.c"
    break;

  case 53: /* prefix_rule: mnt_rule  */
#line 793 "parser_yacc.y"
                       { (yyval.prefix_entry) = (yyvsp[0].mnt_entry); }
#line 2543 "parser_yacc.c"
    break;

  case 54: /* prefix_rule: dbus_rule  */
#line 794 "parser_yacc.y"
                    { (yyval.prefix_entry) = (yyvsp[0].dbus_entry); }
#line 2549 "parser_yacc.c"
    break;

  case 55: /* prefix_rule: signal_rule  */
#line 795 "parser_yacc.y"
                      { (yyval.prefix_entry) = (yyvsp[0].signal_entry); }
#line 2555 "parser_yacc.c"
    break;

  case 56: /* prefix_rule: ptrace_rule  */
#line 796 "parser_yacc.y"
                      { (yyval.prefix_entry) = (yyvsp[0].ptrace_entry); }
#line 2561 "parser_yacc.c"
    break;

  case 57: /* prefix_rule: unix_rule  */
#line 797 "parser_yacc.y"
                    { (yyval.prefix_entry) = (yyvsp[0].unix_entry); }
#line 2567 "parser_yacc.c"
    break;

  case 58: /* prefix_rule: userns_rule  */
#line 798 "parser_yacc.y"
                      { (yyval.prefix_entry) = (yyvsp[0].userns_entry); }
#line 2573 "parser_yacc.c"
    break;

  case 59: /* prefix_rule: mqueue_rule  */
#line 799 "parser_yacc.y"
                      { (yyval.prefix_entry) = (yyvsp[0].mqueue_entry); }
#line 2579 "parser_yacc.c"
    break;

  case 60: /* prefix_rule: io_uring_rule  */
#line 800 "parser_yacc.y"
                        { (yyval.prefix_entry) = (yyvsp[0].io_uring_entry); }
#line 2585 "parser_yacc.c"
    break;

  case 61: /* rules: rules opt_prefix prefix_rule  */
#line 803 "parser_yacc.y"
        {
		const char *error;
		if (!(yyvsp[0].prefix_entry)->add_prefix((yyvsp[-1].prefix), error))
			yyerror(error);
		(yyvsp[-2].prof)->rule_ents.push_back((yyvsp[0].prefix_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2597 "parser_yacc.c"
    break;

  case 62: /* rules: rules opt_prefix change_profile  */
#line 812 "parser_yacc.y"
        {
		PDEBUG("matched: rules change_profile\n");
		PDEBUG("rules change_profile: (%s)\n", (yyvsp[0].user_entry)->name);
		if (!(yyvsp[0].user_entry))
			yyerror(_("Assert: `change_profile' returned NULL."));
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on unix rules"));
		if (((yyvsp[-1].prefix).rule_mode == RULE_DENY) && (yyvsp[-1].prefix).audit == AUDIT_FORCE) {
			(yyvsp[0].user_entry)->rule_mode = RULE_DENY;
		} else if ((yyvsp[-1].prefix).rule_mode == RULE_DENY) {
			(yyvsp[0].user_entry)->rule_mode = RULE_DENY;
			(yyvsp[0].user_entry)->audit = AUDIT_FORCE;
		} else if ((yyvsp[-1].prefix).audit != AUDIT_UNSPECIFIED) {
			(yyvsp[0].user_entry)->audit = (yyvsp[-1].prefix).audit;
		}
		add_entry_to_policy((yyvsp[-2].prof), (yyvsp[0].user_entry));
		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2620 "parser_yacc.c"
    break;

  case 63: /* rules: rules opt_prefix capability  */
#line 832 "parser_yacc.y"
        {
		if ((yyvsp[-1].prefix).owner)
			yyerror(_("owner prefix not allowed on capability rules"));

		if ((yyvsp[-1].prefix).rule_mode == RULE_DENY && (yyvsp[-1].prefix).audit == AUDIT_FORCE) {
			(yyvsp[-2].prof)->caps.deny |= (yyvsp[0].cap);
		} else if ((yyvsp[-1].prefix).rule_mode == RULE_DENY) {
			(yyvsp[-2].prof)->caps.deny |= (yyvsp[0].cap);
			(yyvsp[-2].prof)->caps.quiet |= (yyvsp[0].cap);
		} else {
			(yyvsp[-2].prof)->caps.allow |= (yyvsp[0].cap);
			if ((yyvsp[-1].prefix).audit != AUDIT_UNSPECIFIED)
				(yyvsp[-2].prof)->caps.audit |= (yyvsp[0].cap);
		}

		(yyval.prof) = (yyvsp[-2].prof);
	}
#line 2642 "parser_yacc.c"
    break;

  case 64: /* rules: rules hat  */
#line 851 "parser_yacc.y"
        {
		PDEBUG("Matched: hat rule\n");
		if (!(yyvsp[0].prof))
			yyerror(_("Assert: 'hat rule' returned NULL."));
		add_hat_to_policy((yyvsp[-1].prof), (yyvsp[0].prof));
		(yyval.prof) = (yyvsp[-1].prof);
	}
#line 2654 "parser_yacc.c"
    break;

  case 65: /* rules: rules local_profile  */
#line 860 "parser_yacc.y"
        {
		PDEBUG("Matched: hat rule\n");
		if (!(yyvsp[0].prof))
			yyerror(_("Assert: 'local_profile rule' returned NULL."));
		add_hat_to_policy((yyvsp[-1].prof), (yyvsp[0].prof));
		(yyval.prof) = (yyvsp[-1].prof);
	}
#line 2666 "parser_yacc.c"
    break;

  case 66: /* rules: rules cond_rule  */
#line 869 "parser_yacc.y"
        {
		PDEBUG("Matched: conditional rules\n");
		(yyval.prof) = merge_policy((yyvsp[-1].prof), (yyvsp[0].prof));
	}
#line 2675 "parser_yacc.c"
    break;

  case 67: /* rules: rules TOK_SET TOK_RLIMIT TOK_ID TOK_LE TOK_VALUE opt_id TOK_END_OF_RULE  */
#line 875 "parser_yacc.y"
        {
		rlim_t value = RLIM_INFINITY;
		long long tmp;
		char *end;

		int limit = get_rlimit((yyvsp[-4].id));
		if (limit == -1)
			yyerror("INVALID RLIMIT '%s'\n", (yyvsp[-4].id));

		if (strcmp((yyvsp[-2].var_val), "infinity") == 0) {
			value = RLIM_INFINITY;
		} else {
			const char *kb = "KB";
			const char *mb = "MB";
			const char *gb = "GB";

			tmp = strtoll((yyvsp[-2].var_val), &end, 0);
			switch (limit) {
			case RLIMIT_CPU:
				if (!end || (yyvsp[-2].var_val) == end || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val));
				tmp = convert_time_units(tmp, SECONDS_P_MS, (yyvsp[-1].id));
				if (tmp == -1LL)
					yyerror("RLIMIT '%s %s' < minimum value of 1s\n", (yyvsp[-4].id), (yyvsp[-2].var_val));
				else if (tmp < 0LL)
					yyerror("RLIMIT '%s' invalid value %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val));
				if (!(yyvsp[-1].id))
					pwarn(WARN_MISSING, _("RLIMIT 'cpu' no units specified using default units of seconds\n"));
				value = tmp;
				break;
#ifdef RLIMIT_RTTIME
			case RLIMIT_RTTIME:
				/* RTTIME is measured in microseconds */
				if (!end || (yyvsp[-2].var_val) == end || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				tmp = convert_time_units(tmp, 1LL, (yyvsp[-1].id));
				if (tmp < 0LL)
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				if (!(yyvsp[-1].id))
					pwarn(WARN_MISSING, _("RLIMIT 'rttime' no units specified using default units of microseconds\n"));
				value = tmp;
				break;
#endif
			case RLIMIT_NOFILE:
			case RLIMIT_NPROC:
			case RLIMIT_LOCKS:
			case RLIMIT_SIGPENDING:
#ifdef RLIMIT_RTPRIO
			case RLIMIT_RTPRIO:
				if (!end || (yyvsp[-2].var_val) == end || (yyvsp[-1].id) || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				value = tmp;
				break;
#endif
#ifdef RLIMIT_NICE
			case RLIMIT_NICE:
				if (!end || (yyvsp[-2].var_val) == end || (yyvsp[-1].id))
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				if (tmp < -20 || tmp > 19)
					yyerror("RLIMIT '%s' out of range (-20 .. 19) %d\n", (yyvsp[-4].id), tmp);
				value = tmp + 20;
				break;
#endif
			case RLIMIT_FSIZE:
			case RLIMIT_DATA:
			case RLIMIT_STACK:
			case RLIMIT_CORE:
			case RLIMIT_RSS:
			case RLIMIT_AS:
			case RLIMIT_MEMLOCK:
			case RLIMIT_MSGQUEUE:
				if ((yyvsp[-2].var_val) == end || tmp < 0)
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id) ? (yyvsp[-1].id) : "");
				if (!(yyvsp[-1].id)) {
					; /* use default of bytes */
				} else if (strstr(kb, (yyvsp[-1].id)) == kb) {
					tmp *= 1024;
				} else if (strstr(mb, (yyvsp[-1].id)) == mb) {
					tmp *= 1024*1024;
				} else if (strstr(gb, (yyvsp[-1].id)) == gb) {
					tmp *= 1024*1024*1024;
				} else {
					yyerror("RLIMIT '%s' invalid value %s %s\n", (yyvsp[-4].id), (yyvsp[-2].var_val), (yyvsp[-1].id));
				}
				value = tmp;
				break;
			default:
				yyerror("Unknown RLIMIT %d\n", (yyvsp[-4].id));
			}
		}
		(yyvsp[-7].prof)->rlimits.specified |= 1 << limit;
		(yyvsp[-7].prof)->rlimits.limits[limit] = value;
		free((yyvsp[-4].id));
		free((yyvsp[-2].var_val));
		(yyval.prof) = (yyvsp[-7].prof);
	}
#line 2776 "parser_yacc.c"
    break;

  case 68: /* cond_rule: TOK_IF expr block  */
#line 974 "parser_yacc.y"
        {
		Profile *ret = NULL;
		PDEBUG("Matched: found conditional rules\n");
		if ((yyvsp[-1].boolean)) {
			ret = (yyvsp[0].prof);
		} else {
			delete (yyvsp[0].prof);
		}
		(yyval.prof) = ret;
	}
#line 2791 "parser_yacc.c"
    break;

  case 69: /* cond_rule: TOK_IF expr block TOK_ELSE block  */
#line 986 "parser_yacc.y"
        {
		Profile *ret = NULL;
		PDEBUG("Matched: found conditional else rules\n");
		if ((yyvsp[-3].boolean)) {
			ret = (yyvsp[-2].prof);
			delete (yyvsp[0].prof);
		} else {
			ret = (yyvsp[0].prof);
			delete (yyvsp[-2].prof);
		}
		(yyval.prof) = ret;
	}
#line 2808 "parser_yacc.c"
    break;

  case 70: /* cond_rule: TOK_IF expr block TOK_ELSE cond_rule  */
#line 1000 "parser_yacc.y"
        {
		Profile *ret = NULL;
		PDEBUG("Matched: found conditional else-if rules\n");
		if ((yyvsp[-3].boolean)) {
			ret = (yyvsp[-2].prof);
			delete (yyvsp[0].prof);
		} else {
			ret = (yyvsp[0].prof);
			delete (yyvsp[-2].prof);
		}
		(yyval.prof) = ret;
	}
#line 2825 "parser_yacc.c"
    break;

  case 71: /* expr: TOK_NOT expr  */
#line 1014 "parser_yacc.y"
        {
		(yyval.boolean) = !(yyvsp[0].boolean);
	}
#line 2833 "parser_yacc.c"
    break;

  case 72: /* expr: TOK_BOOL_VAR  */
#line 1019 "parser_yacc.y"
        {
		char *var_name = process_var((yyvsp[0].bool_var));
		int boolean  = get_boolean_var(var_name);
		PDEBUG("Matched: boolean expr %s value: %d\n", (yyvsp[0].bool_var), boolean);
		if (boolean < 0) {
			/* FIXME check for set var */
			yyerror(_("Unset boolean variable %s used in if-expression"),
				(yyvsp[0].bool_var));
		}
		(yyval.boolean) = boolean;
		free(var_name);
		free((yyvsp[0].bool_var));
	}
#line 2851 "parser_yacc.c"
    break;

  case 73: /* expr: TOK_DEFINED TOK_SET_VAR  */
#line 1034 "parser_yacc.y"
        {
		char *var_name = process_var((yyvsp[0].set_var));
		void *set_value = get_set_var(var_name);
		PDEBUG("Matched: defined set expr %s value %lx\n", (yyvsp[0].set_var), (long) set_value);
		(yyval.boolean) = !! (long) set_value;
		free(var_name);
		free((yyvsp[0].set_var));
	}
#line 2864 "parser_yacc.c"
    break;

  case 74: /* expr: TOK_DEFINED TOK_BOOL_VAR  */
#line 1044 "parser_yacc.y"
        {
		char *var_name = process_var((yyvsp[0].bool_var));
		int boolean = get_boolean_var(var_name);
		PDEBUG("Matched: defined set expr %s value %d\n", (yyvsp[0].bool_var), boolean);
		(yyval.boolean) = (boolean != -1);
		free(var_name);
		free((yyvsp[0].bool_var));
	}
#line 2877 "parser_yacc.c"
    break;

  case 75: /* id_or_var: TOK_ID  */
#line 1053 "parser_yacc.y"
                  { (yyval.id) = (yyvsp[0].id); }
#line 2883 "parser_yacc.c"
    break;

  case 76: /* id_or_var: TOK_SET_VAR  */
#line 1054 "parser_yacc.y"
                       { (yyval.id) = (yyvsp[0].set_var); }
#line 2889 "parser_yacc.c"
    break;

  case 77: /* opt_target: %empty  */
#line 1056 "parser_yacc.y"
                          { (yyval.id) = NULL; }
#line 2895 "parser_yacc.c"
    break;

  case 78: /* opt_target: TOK_ARROW id_or_var  */
#line 1057 "parser_yacc.y"
                                { (yyval.id) = (yyvsp[0].id); }
#line 2901 "parser_yacc.c"
    break;

  case 79: /* opt_named_transition: %empty  */
#line 1059 "parser_yacc.y"
                      { /* nothing */ (yyval.id) = NULL; }
#line 2907 "parser_yacc.c"
    break;

  case 80: /* opt_named_transition: TOK_ARROW id_or_var  */
#line 1061 "parser_yacc.y"
        {
		(yyval.id) = (yyvsp[0].id);
	}
#line 2915 "parser_yacc.c"
    break;

  case 81: /* rule: file_rule  */
#line 1065 "parser_yacc.y"
                { (yyval.user_entry) = (yyvsp[0].user_entry); }
#line 2921 "parser_yacc.c"
    break;

  case 82: /* rule: link_rule  */
#line 1066 "parser_yacc.y"
                    { (yyval.user_entry) = (yyvsp[0].user_entry); }
#line 2927 "parser_yacc.c"
    break;

  case 83: /* abi_rule: TOK_ABI TOK_ID TOK_END_OF_RULE  */
#line 1069 "parser_yacc.y"
        {
		abi_features((yyvsp[-1].id), true);
		free((yyvsp[-1].id));
		/* $$ = nothing, not used */
	}
#line 2937 "parser_yacc.c"
    break;

  case 84: /* abi_rule: TOK_ABI TOK_VALUE TOK_END_OF_RULE  */
#line 1075 "parser_yacc.y"
        {
		abi_features((yyvsp[-1].var_val), false);
		free((yyvsp[-1].var_val));
		/* $$ = nothing, not used */
	}
#line 2947 "parser_yacc.c"
    break;

  case 85: /* opt_exec_mode: %empty  */
#line 1081 "parser_yacc.y"
               { /* nothing */ (yyval.boolean) = EXEC_MODE_EMPTY; }
#line 2953 "parser_yacc.c"
    break;

  case 86: /* opt_exec_mode: TOK_UNSAFE  */
#line 1082 "parser_yacc.y"
                     { (yyval.boolean) = EXEC_MODE_UNSAFE; }
#line 2959 "parser_yacc.c"
    break;

  case 87: /* opt_exec_mode: TOK_SAFE  */
#line 1083 "parser_yacc.y"
                   { (yyval.boolean) = EXEC_MODE_SAFE; }
#line 2965 "parser_yacc.c"
    break;

  case 88: /* opt_file: %empty  */
#line 1085 "parser_yacc.y"
          { /* nothing */ (yyval.boolean) = 0; }
#line 2971 "parser_yacc.c"
    break;

  case 89: /* opt_file: TOK_FILE  */
#line 1086 "parser_yacc.y"
                   { (yyval.boolean) = 1; }
#line 2977 "parser_yacc.c"
    break;

  case 90: /* frule: id_or_var file_perms opt_named_transition TOK_END_OF_RULE  */
#line 1089 "parser_yacc.y"
        {
		(yyval.user_entry) = do_file_rule((yyvsp[-3].id), (yyvsp[-2].fperms), NULL, (yyvsp[-1].id));
	}
#line 2985 "parser_yacc.c"
    break;

  case 91: /* frule: file_perms opt_subset_flag id_or_var opt_named_transition TOK_END_OF_RULE  */
#line 1094 "parser_yacc.y"
        {
		if ((yyvsp[-3].boolean) && ((yyvsp[-4].fperms) & ~AA_LINK_BITS))
			yyerror(_("subset can only be used with link rules."));
		if ((yyvsp[-1].id) && ((yyvsp[-4].fperms) & AA_LINK_BITS) && ((yyvsp[-4].fperms) & AA_EXEC_BITS))
			yyerror(_("link and exec perms conflict on a file rule using ->"));
		if ((yyvsp[-1].id) && label_contains_ns((yyvsp[-1].id)) && ((yyvsp[-4].fperms) & AA_LINK_BITS))
			yyerror(_("link perms are not allowed on a named profile transition.\n"));

		if (((yyvsp[-4].fperms) & AA_LINK_BITS)) {
			(yyval.user_entry) = do_file_rule((yyvsp[-2].id), (yyvsp[-4].fperms), (yyvsp[-1].id), NULL);
			(yyval.user_entry)->subset = (yyvsp[-3].boolean);

		} else {
			(yyval.user_entry) = do_file_rule((yyvsp[-2].id), (yyvsp[-4].fperms), NULL, (yyvsp[-1].id));
		}
 	}
#line 3006 "parser_yacc.c"
    break;

  case 92: /* file_rule: TOK_FILE TOK_END_OF_RULE  */
#line 1112 "parser_yacc.y"
        {
		char *path = strdup("/{**,}");
		int perms = ((AA_BASE_PERMS & ~AA_EXEC_TYPE) |
			     (AA_EXEC_INHERIT | AA_MAY_EXEC));
		/* duplicate to other permission set */
		perms |= perms << AA_OTHER_SHIFT;
		if (!path)
			yyerror(_("Memory allocation error."));
		(yyval.user_entry) = do_file_rule(path, perms, NULL, NULL);
	}
#line 3021 "parser_yacc.c"
    break;

  case 93: /* file_rule: opt_file file_rule_tail  */
#line 1122 "parser_yacc.y"
                                  { (yyval.user_entry) = (yyvsp[0].user_entry); }
#line 3027 "parser_yacc.c"
    break;

  case 94: /* file_rule_tail: opt_exec_mode frule  */
#line 1126 "parser_yacc.y"
        {
		if ((yyvsp[-1].boolean) != EXEC_MODE_EMPTY) {
			if (!((yyvsp[0].user_entry)->perms & AA_EXEC_BITS))
				yyerror(_("unsafe rule missing exec permissions"));
			if ((yyvsp[-1].boolean) == EXEC_MODE_UNSAFE) {
				(yyvsp[0].user_entry)->perms |= (((yyvsp[0].user_entry)->perms & AA_EXEC_BITS) << 8) &
					 ALL_AA_EXEC_UNSAFE;
			}
			else if ((yyvsp[-1].boolean) == EXEC_MODE_SAFE)
				(yyvsp[0].user_entry)->perms &= ~ALL_AA_EXEC_UNSAFE;
		}
		(yyval.user_entry) = (yyvsp[0].user_entry);
	}
#line 3045 "parser_yacc.c"
    break;

  case 95: /* file_rule_tail: opt_exec_mode id_or_var file_perms id_or_var  */
#line 1141 "parser_yacc.y"
        {
		/* Oopsie, we appear to be missing an EOL marker. If we
		 * were *smart*, we could work around it. Since we're
		 * obviously not smart, we'll just punt with a more
		 * sensible error. */
		yyerror(_("missing an end of line character? (entry: %s)"), (yyvsp[-2].id));
	}
#line 3057 "parser_yacc.c"
    break;

  case 96: /* link_rule: TOK_LINK opt_subset_flag id_or_var TOK_ARROW id_or_var TOK_END_OF_RULE  */
#line 1150 "parser_yacc.y"
        {
		struct cod_entry *entry;
		PDEBUG("Matched: link tok_id (%s) -> (%s)\n", (yyvsp[-3].id), (yyvsp[-1].id));
		entry = new_entry((yyvsp[-3].id), AA_LINK_BITS, (yyvsp[-1].id));
		entry->subset = (yyvsp[-4].boolean);
		PDEBUG("rule.entry: link (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	}
#line 3070 "parser_yacc.c"
    break;

  case 97: /* network_rule: TOK_NETWORK TOK_END_OF_RULE  */
#line 1160 "parser_yacc.y"
        {
		size_t family;
		struct aa_network_entry *new_entry, *entry = NULL;
		for (family = AF_UNSPEC; family < get_af_max(); family++) {
			new_entry = new_network_ent(family, 0xffffffff,
						    0xffffffff);
			if (!new_entry)
				yyerror(_("Memory allocation error."));
			new_entry->next = entry;
			entry = new_entry;
		}
		(yyval.network_entry) = entry;
	}
#line 3088 "parser_yacc.c"
    break;

  case 98: /* network_rule: TOK_NETWORK TOK_ID TOK_END_OF_RULE  */
#line 1175 "parser_yacc.y"
        {
		struct aa_network_entry *entry;
		entry = network_entry((yyvsp[-1].id), NULL, NULL);
		if (!entry)
			/* test for short circuiting of family */
			entry = network_entry(NULL, (yyvsp[-1].id), NULL);
		if (!entry)
			yyerror(_("Invalid network entry."));
		free((yyvsp[-1].id));
		(yyval.network_entry) = entry;
	}
#line 3104 "parser_yacc.c"
    break;

  case 99: /* network_rule: TOK_NETWORK TOK_ID TOK_ID TOK_END_OF_RULE  */
#line 1188 "parser_yacc.y"
        {
		struct aa_network_entry *entry;
		entry = network_entry((yyvsp[-2].id), (yyvsp[-1].id), NULL);
		if (!entry)
			yyerror(_("Invalid network entry."));
		free((yyvsp[-2].id));
		free((yyvsp[-1].id));
		(yyval.network_entry) = entry;
	}
#line 3118 "parser_yacc.c"
    break;

  case 100: /* cond: TOK_CONDID  */
#line 1199 "parser_yacc.y"
        {
		struct cond_entry *ent;
		ent = new_cond_entry((yyvsp[0].id), 0, NULL);
		if (!ent)
			yyerror(_("Memory allocation error."));
		(yyval.cond_entry) = ent;
	}
#line 3130 "parser_yacc.c"
    break;

  case 101: /* cond: TOK_CONDID TOK_EQUALS TOK_VALUE  */
#line 1208 "parser_yacc.y"
        {
		struct cond_entry *ent;
		struct value_list *value = new_value_list((yyvsp[0].var_val));
		if (!value)
			yyerror(_("Memory allocation error."));
		ent = new_cond_entry((yyvsp[-2].id), 1, value);
		if (!ent) {
			free_value_list(value);
			yyerror(_("Memory allocation error."));
		}
		(yyval.cond_entry) = ent;
	}
#line 3147 "parser_yacc.c"
    break;

  case 102: /* cond: TOK_CONDID TOK_EQUALS TOK_OPENPAREN valuelist TOK_CLOSEPAREN  */
#line 1222 "parser_yacc.y"
        {
		struct cond_entry *ent = new_cond_entry((yyvsp[-4].id), 1, (yyvsp[-1].val_list));

		if (!ent)
			yyerror(_("Memory allocation error."));
		(yyval.cond_entry) = ent;
	}
#line 3159 "parser_yacc.c"
    break;

  case 103: /* cond: TOK_CONDID TOK_IN TOK_OPENPAREN valuelist TOK_CLOSEPAREN  */
#line 1232 "parser_yacc.y"
        {
		struct cond_entry *ent = new_cond_entry((yyvsp[-4].id), 0, (yyvsp[-1].val_list));

		if (!ent)
			yyerror(_("Memory allocation error."));
		(yyval.cond_entry) = ent;
	}
#line 3171 "parser_yacc.c"
    break;

  case 104: /* opt_conds: %empty  */
#line 1240 "parser_yacc.y"
           { /* nothing */ (yyval.cond_entry) = NULL; }
#line 3177 "parser_yacc.c"
    break;

  case 105: /* opt_conds: opt_conds cond  */
#line 1242 "parser_yacc.y"
        {
		(yyvsp[0].cond_entry)->next = (yyvsp[-1].cond_entry);
		(yyval.cond_entry) = (yyvsp[0].cond_entry);
	}
#line 3186 "parser_yacc.c"
    break;

  case 106: /* cond_list: TOK_CONDLISTID TOK_EQUALS TOK_OPENPAREN opt_conds TOK_CLOSEPAREN  */
#line 1248 "parser_yacc.y"
        {
		(yyval.cond_entry_list).name = (yyvsp[-4].id);
		(yyval.cond_entry_list).list = (yyvsp[-1].cond_entry);
	}
#line 3195 "parser_yacc.c"
    break;

  case 107: /* opt_cond_list: %empty  */
#line 1253 "parser_yacc.y"
               { /* nothing */ (yyval.cond_entry_list) = { NULL, NULL }; }
#line 3201 "parser_yacc.c"
    break;

  case 108: /* opt_cond_list: cond_list  */
#line 1254 "parser_yacc.y"
                    { (yyval.cond_entry_list) = (yyvsp[0].cond_entry_list); }
#line 3207 "parser_yacc.c"
    break;

  case 109: /* mnt_rule: TOK_MOUNT opt_conds opt_id TOK_END_OF_RULE  */
#line 1257 "parser_yacc.y"
        {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-2].cond_entry), (yyvsp[-1].id), NULL, NULL, AA_MAY_MOUNT);
	}
#line 3215 "parser_yacc.c"
    break;

  case 110: /* mnt_rule: TOK_MOUNT opt_conds opt_id TOK_ARROW opt_conds TOK_ID TOK_END_OF_RULE  */
#line 1262 "parser_yacc.y"
        {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-5].cond_entry), (yyvsp[-4].id), (yyvsp[-2].cond_entry), (yyvsp[-1].id), AA_MAY_MOUNT);
	}
#line 3223 "parser_yacc.c"
    break;

  case 111: /* mnt_rule: TOK_REMOUNT opt_conds opt_id TOK_END_OF_RULE  */
#line 1267 "parser_yacc.y"
        {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-2].cond_entry), NULL, NULL, (yyvsp[-1].id), AA_DUMMY_REMOUNT);
	}
#line 3231 "parser_yacc.c"
    break;

  case 112: /* mnt_rule: TOK_UMOUNT opt_conds opt_id TOK_END_OF_RULE  */
#line 1272 "parser_yacc.y"
        {
		(yyval.mnt_entry) = do_mnt_rule((yyvsp[-2].cond_entry), NULL, NULL, (yyvsp[-1].id), AA_MAY_UMOUNT);
	}
#line 3239 "parser_yacc.c"
    break;

  case 113: /* mnt_rule: TOK_PIVOTROOT opt_conds opt_id opt_target TOK_END_OF_RULE  */
#line 1277 "parser_yacc.y"
        {
		(yyval.mnt_entry) = do_pivot_rule((yyvsp[-3].cond_entry), (yyvsp[-2].id), (yyvsp[-1].id));
	}
#line 3247 "parser_yacc.c"
    break;

  case 114: /* dbus_perm: TOK_VALUE  */
#line 1282 "parser_yacc.y"
        {
		if (strcmp((yyvsp[0].var_val), "bind") == 0)
			(yyval.fperms) = AA_DBUS_BIND;
		else if (strcmp((yyvsp[0].var_val), "send") == 0 || strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fperms) = AA_DBUS_SEND;
		else if (strcmp((yyvsp[0].var_val), "receive") == 0 || strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fperms) = AA_DBUS_RECEIVE;
		else if (strcmp((yyvsp[0].var_val), "eavesdrop") == 0)
			(yyval.fperms) = AA_DBUS_EAVESDROP;
		else if ((yyvsp[0].var_val)) {
			parse_dbus_perms((yyvsp[0].var_val), &(yyval.fperms), 1);
		} else
			(yyval.fperms) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3269 "parser_yacc.c"
    break;

  case 115: /* dbus_perm: TOK_BIND  */
#line 1299 "parser_yacc.y"
                   { (yyval.fperms) = AA_DBUS_BIND; }
#line 3275 "parser_yacc.c"
    break;

  case 116: /* dbus_perm: TOK_SEND  */
#line 1300 "parser_yacc.y"
                   { (yyval.fperms) = AA_DBUS_SEND; }
#line 3281 "parser_yacc.c"
    break;

  case 117: /* dbus_perm: TOK_RECEIVE  */
#line 1301 "parser_yacc.y"
                      { (yyval.fperms) = AA_DBUS_RECEIVE; }
#line 3287 "parser_yacc.c"
    break;

  case 118: /* dbus_perm: TOK_READ  */
#line 1302 "parser_yacc.y"
                   { (yyval.fperms) = AA_DBUS_RECEIVE; }
#line 3293 "parser_yacc.c"
    break;

  case 119: /* dbus_perm: TOK_WRITE  */
#line 1303 "parser_yacc.y"
                    { (yyval.fperms) = AA_DBUS_SEND; }
#line 3299 "parser_yacc.c"
    break;

  case 120: /* dbus_perm: TOK_EAVESDROP  */
#line 1304 "parser_yacc.y"
                        { (yyval.fperms) = AA_DBUS_EAVESDROP; }
#line 3305 "parser_yacc.c"
    break;

  case 121: /* dbus_perm: TOK_MODE  */
#line 1306 "parser_yacc.y"
        {
		parse_dbus_perms((yyvsp[0].mode), &(yyval.fperms), 1);
		free((yyvsp[0].mode));
	}
#line 3314 "parser_yacc.c"
    break;

  case 122: /* dbus_perms: %empty  */
#line 1311 "parser_yacc.y"
            { /* nothing */ (yyval.fperms) = 0; }
#line 3320 "parser_yacc.c"
    break;

  case 123: /* dbus_perms: dbus_perms dbus_perm  */
#line 1312 "parser_yacc.y"
                               { (yyval.fperms) = (yyvsp[-1].fperms) | (yyvsp[0].fperms); }
#line 3326 "parser_yacc.c"
    break;

  case 124: /* dbus_perms: dbus_perms TOK_COMMA dbus_perm  */
#line 1313 "parser_yacc.y"
                                         { (yyval.fperms) = (yyvsp[-2].fperms) | (yyvsp[0].fperms); }
#line 3332 "parser_yacc.c"
    break;

  case 125: /* opt_dbus_perm: %empty  */
#line 1315 "parser_yacc.y"
               { /* nothing */ (yyval.fperms) = 0; }
#line 3338 "parser_yacc.c"
    break;

  case 126: /* opt_dbus_perm: dbus_perm  */
#line 1316 "parser_yacc.y"
                     { (yyval.fperms) = (yyvsp[0].fperms); }
#line 3344 "parser_yacc.c"
    break;

  case 127: /* opt_dbus_perm: TOK_OPENPAREN dbus_perms TOK_CLOSEPAREN  */
#line 1317 "parser_yacc.y"
                                                  { (yyval.fperms) = (yyvsp[-1].fperms); }
#line 3350 "parser_yacc.c"
    break;

  case 128: /* dbus_rule: TOK_DBUS opt_dbus_perm opt_conds opt_cond_list TOK_END_OF_RULE  */
#line 1320 "parser_yacc.y"
        {
		dbus_rule *ent;

		if ((yyvsp[-1].cond_entry_list).name) {
			if (strcmp((yyvsp[-1].cond_entry_list).name, "peer") != 0)
				yyerror(_("dbus rule: invalid conditional group %s=()"), (yyvsp[-1].cond_entry_list).name);
			free((yyvsp[-1].cond_entry_list).name);
		}
		ent = new dbus_rule((yyvsp[-3].fperms), (yyvsp[-2].cond_entry), (yyvsp[-1].cond_entry_list).list);
		if (!ent) {
			yyerror(_("Memory allocation error."));
		}
		(yyval.dbus_entry) = ent;
	}
#line 3369 "parser_yacc.c"
    break;

  case 129: /* net_perm: TOK_VALUE  */
#line 1336 "parser_yacc.y"
        {
		if (strcmp((yyvsp[0].var_val), "create") == 0)
			(yyval.fperms) = AA_NET_CREATE;
		else if (strcmp((yyvsp[0].var_val), "bind") == 0)
			(yyval.fperms) = AA_NET_BIND;
		else if (strcmp((yyvsp[0].var_val), "listen") == 0)
			(yyval.fperms) = AA_NET_LISTEN;
		else if (strcmp((yyvsp[0].var_val), "accept") == 0)
			(yyval.fperms) = AA_NET_ACCEPT;
		else if (strcmp((yyvsp[0].var_val), "connect") == 0)
			(yyval.fperms) = AA_NET_CONNECT;
		else if (strcmp((yyvsp[0].var_val), "shutdown") == 0)
			(yyval.fperms) = AA_NET_SHUTDOWN;
		else if (strcmp((yyvsp[0].var_val), "getattr") == 0)
			(yyval.fperms) = AA_NET_GETATTR;
		else if (strcmp((yyvsp[0].var_val), "setattr") == 0)
			(yyval.fperms) = AA_NET_SETATTR;
		else if (strcmp((yyvsp[0].var_val), "getopt") == 0)
			(yyval.fperms) = AA_NET_GETOPT;
		else if (strcmp((yyvsp[0].var_val), "setopt") == 0)
			(yyval.fperms) = AA_NET_SETOPT;
		else if (strcmp((yyvsp[0].var_val), "send") == 0 || strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fperms) = AA_NET_SEND;
		else if (strcmp((yyvsp[0].var_val), "receive") == 0 || strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fperms) = AA_NET_RECEIVE;
		else if ((yyvsp[0].var_val)) {
			parse_net_perms((yyvsp[0].var_val), &(yyval.fperms), 1);
		} else
			(yyval.fperms) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3407 "parser_yacc.c"
    break;

  case 130: /* net_perm: TOK_CREATE  */
#line 1369 "parser_yacc.y"
                     { (yyval.fperms) = AA_NET_CREATE; }
#line 3413 "parser_yacc.c"
    break;

  case 131: /* net_perm: TOK_BIND  */
#line 1370 "parser_yacc.y"
                   { (yyval.fperms) = AA_NET_BIND; }
#line 3419 "parser_yacc.c"
    break;

  case 132: /* net_perm: TOK_LISTEN  */
#line 1371 "parser_yacc.y"
                     { (yyval.fperms) = AA_NET_LISTEN; }
#line 3425 "parser_yacc.c"
    break;

  case 133: /* net_perm: TOK_ACCEPT  */
#line 1372 "parser_yacc.y"
                     { (yyval.fperms) = AA_NET_ACCEPT; }
#line 3431 "parser_yacc.c"
    break;

  case 134: /* net_perm: TOK_CONNECT  */
#line 1373 "parser_yacc.y"
                      { (yyval.fperms) = AA_NET_CONNECT; }
#line 3437 "parser_yacc.c"
    break;

  case 135: /* net_perm: TOK_SHUTDOWN  */
#line 1374 "parser_yacc.y"
                       { (yyval.fperms) = AA_NET_SHUTDOWN; }
#line 3443 "parser_yacc.c"
    break;

  case 136: /* net_perm: TOK_GETATTR  */
#line 1375 "parser_yacc.y"
                      { (yyval.fperms) = AA_NET_GETATTR; }
#line 3449 "parser_yacc.c"
    break;

  case 137: /* net_perm: TOK_SETATTR  */
#line 1376 "parser_yacc.y"
                      { (yyval.fperms) = AA_NET_SETATTR; }
#line 3455 "parser_yacc.c"
    break;

  case 138: /* net_perm: TOK_GETOPT  */
#line 1377 "parser_yacc.y"
                     { (yyval.fperms) = AA_NET_GETOPT; }
#line 3461 "parser_yacc.c"
    break;

  case 139: /* net_perm: TOK_SETOPT  */
#line 1378 "parser_yacc.y"
                     { (yyval.fperms) = AA_NET_SETOPT; }
#line 3467 "parser_yacc.c"
    break;

  case 140: /* net_perm: TOK_SEND  */
#line 1379 "parser_yacc.y"
                   { (yyval.fperms) = AA_NET_SEND; }
#line 3473 "parser_yacc.c"
    break;

  case 141: /* net_perm: TOK_RECEIVE  */
#line 1380 "parser_yacc.y"
                      { (yyval.fperms) = AA_NET_RECEIVE; }
#line 3479 "parser_yacc.c"
    break;

  case 142: /* net_perm: TOK_READ  */
#line 1381 "parser_yacc.y"
                   { (yyval.fperms) = AA_NET_RECEIVE; }
#line 3485 "parser_yacc.c"
    break;

  case 143: /* net_perm: TOK_WRITE  */
#line 1382 "parser_yacc.y"
                    { (yyval.fperms) = AA_NET_SEND; }
#line 3491 "parser_yacc.c"
    break;

  case 144: /* net_perm: TOK_MODE  */
#line 1384 "parser_yacc.y"
        {
		parse_unix_perms((yyvsp[0].mode), &(yyval.fperms), 1);
		free((yyvsp[0].mode));
	}
#line 3500 "parser_yacc.c"
    break;

  case 145: /* net_perms: %empty  */
#line 1389 "parser_yacc.y"
           { /* nothing */ (yyval.fperms) = 0; }
#line 3506 "parser_yacc.c"
    break;

  case 146: /* net_perms: net_perms net_perm  */
#line 1390 "parser_yacc.y"
                             { (yyval.fperms) = (yyvsp[-1].fperms) | (yyvsp[0].fperms); }
#line 3512 "parser_yacc.c"
    break;

  case 147: /* net_perms: net_perms TOK_COMMA net_perm  */
#line 1391 "parser_yacc.y"
                                       { (yyval.fperms) = (yyvsp[-2].fperms) | (yyvsp[0].fperms); }
#line 3518 "parser_yacc.c"
    break;

  case 148: /* opt_net_perm: %empty  */
#line 1393 "parser_yacc.y"
              { /* nothing */ (yyval.fperms) = 0; }
#line 3524 "parser_yacc.c"
    break;

  case 149: /* opt_net_perm: net_perm  */
#line 1394 "parser_yacc.y"
                    { (yyval.fperms) = (yyvsp[0].fperms); }
#line 3530 "parser_yacc.c"
    break;

  case 150: /* opt_net_perm: TOK_OPENPAREN net_perms TOK_CLOSEPAREN  */
#line 1395 "parser_yacc.y"
                                                 { (yyval.fperms) = (yyvsp[-1].fperms); }
#line 3536 "parser_yacc.c"
    break;

  case 151: /* unix_rule: TOK_UNIX opt_net_perm opt_conds opt_cond_list TOK_END_OF_RULE  */
#line 1398 "parser_yacc.y"
        {
		unix_rule *ent;

		if ((yyvsp[-1].cond_entry_list).name) {
			if (strcmp((yyvsp[-1].cond_entry_list).name, "peer") != 0)
				yyerror(_("unix rule: invalid conditional group %s=()"), (yyvsp[-1].cond_entry_list).name);
			free((yyvsp[-1].cond_entry_list).name);
		}
		ent = new unix_rule((yyvsp[-3].fperms), (yyvsp[-2].cond_entry), (yyvsp[-1].cond_entry_list).list);
		if (!ent) {
			yyerror(_("Memory allocation error."));
		}
		(yyval.unix_entry) = ent;
	}
#line 3555 "parser_yacc.c"
    break;

  case 152: /* signal_perm: TOK_VALUE  */
#line 1414 "parser_yacc.y"
        {
		if (strcmp((yyvsp[0].var_val), "send") == 0 || strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fperms) = AA_MAY_SEND;
		else if (strcmp((yyvsp[0].var_val), "receive") == 0 || strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fperms) = AA_MAY_RECEIVE;
		else if ((yyvsp[0].var_val)) {
			parse_signal_perms((yyvsp[0].var_val), &(yyval.fperms), 1);
		} else
			(yyval.fperms) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3573 "parser_yacc.c"
    break;

  case 153: /* signal_perm: TOK_SEND  */
#line 1427 "parser_yacc.y"
                   { (yyval.fperms) = AA_MAY_SEND; }
#line 3579 "parser_yacc.c"
    break;

  case 154: /* signal_perm: TOK_RECEIVE  */
#line 1428 "parser_yacc.y"
                      { (yyval.fperms) = AA_MAY_RECEIVE; }
#line 3585 "parser_yacc.c"
    break;

  case 155: /* signal_perm: TOK_READ  */
#line 1429 "parser_yacc.y"
                   { (yyval.fperms) = AA_MAY_RECEIVE; }
#line 3591 "parser_yacc.c"
    break;

  case 156: /* signal_perm: TOK_WRITE  */
#line 1430 "parser_yacc.y"
                    { (yyval.fperms) = AA_MAY_SEND; }
#line 3597 "parser_yacc.c"
    break;

  case 157: /* signal_perm: TOK_MODE  */
#line 1432 "parser_yacc.y"
        {
		parse_signal_perms((yyvsp[0].mode), &(yyval.fperms), 1);
		free((yyvsp[0].mode));
	}
#line 3606 "parser_yacc.c"
    break;

  case 158: /* signal_perms: %empty  */
#line 1437 "parser_yacc.y"
              { /* nothing */ (yyval.fperms) = 0; }
#line 3612 "parser_yacc.c"
    break;

  case 159: /* signal_perms: signal_perms signal_perm  */
#line 1438 "parser_yacc.y"
                                   { (yyval.fperms) = (yyvsp[-1].fperms) | (yyvsp[0].fperms); }
#line 3618 "parser_yacc.c"
    break;

  case 160: /* signal_perms: signal_perms TOK_COMMA signal_perm  */
#line 1439 "parser_yacc.y"
                                             { (yyval.fperms) = (yyvsp[-2].fperms) | (yyvsp[0].fperms); }
#line 3624 "parser_yacc.c"
    break;

  case 161: /* opt_signal_perm: %empty  */
#line 1441 "parser_yacc.y"
                 { /* nothing */ (yyval.fperms) = 0; }
#line 3630 "parser_yacc.c"
    break;

  case 162: /* opt_signal_perm: signal_perm  */
#line 1442 "parser_yacc.y"
                      { (yyval.fperms) = (yyvsp[0].fperms); }
#line 3636 "parser_yacc.c"
    break;

  case 163: /* opt_signal_perm: TOK_OPENPAREN signal_perms TOK_CLOSEPAREN  */
#line 1443 "parser_yacc.y"
                                                    { (yyval.fperms) = (yyvsp[-1].fperms); }
#line 3642 "parser_yacc.c"
    break;

  case 164: /* signal_rule: TOK_SIGNAL opt_signal_perm opt_conds TOK_END_OF_RULE  */
#line 1446 "parser_yacc.y"
        {
		signal_rule *ent = new signal_rule((yyvsp[-2].fperms), (yyvsp[-1].cond_entry));
		(yyval.signal_entry) = ent;
	}
#line 3651 "parser_yacc.c"
    break;

  case 165: /* ptrace_perm: TOK_VALUE  */
#line 1452 "parser_yacc.y"
        {
		if (strcmp((yyvsp[0].var_val), "trace") == 0 || strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fperms) = AA_MAY_TRACE;
		else if (strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fperms) = AA_MAY_READ;
		else if (strcmp((yyvsp[0].var_val), "tracedby") == 0)
			(yyval.fperms) = AA_MAY_TRACEDBY;
		else if (strcmp((yyvsp[0].var_val), "readby") == 0)
			(yyval.fperms) = AA_MAY_READBY;
		else if ((yyvsp[0].var_val))
			parse_ptrace_perms((yyvsp[0].var_val), &(yyval.fperms), 1);
		else
			(yyval.fperms) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3673 "parser_yacc.c"
    break;

  case 166: /* ptrace_perm: TOK_TRACE  */
#line 1469 "parser_yacc.y"
                    { (yyval.fperms) = AA_MAY_TRACE; }
#line 3679 "parser_yacc.c"
    break;

  case 167: /* ptrace_perm: TOK_TRACEDBY  */
#line 1470 "parser_yacc.y"
                       { (yyval.fperms) = AA_MAY_TRACEDBY; }
#line 3685 "parser_yacc.c"
    break;

  case 168: /* ptrace_perm: TOK_READ  */
#line 1471 "parser_yacc.y"
                   { (yyval.fperms) = AA_MAY_READ; }
#line 3691 "parser_yacc.c"
    break;

  case 169: /* ptrace_perm: TOK_WRITE  */
#line 1472 "parser_yacc.y"
                    { (yyval.fperms) = AA_MAY_TRACE; }
#line 3697 "parser_yacc.c"
    break;

  case 170: /* ptrace_perm: TOK_READBY  */
#line 1473 "parser_yacc.y"
                     { (yyval.fperms) = AA_MAY_READBY; }
#line 3703 "parser_yacc.c"
    break;

  case 171: /* ptrace_perm: TOK_MODE  */
#line 1475 "parser_yacc.y"
        {
		parse_ptrace_perms((yyvsp[0].mode), &(yyval.fperms), 1);
		free((yyvsp[0].mode));
	}
#line 3712 "parser_yacc.c"
    break;

  case 172: /* ptrace_perms: %empty  */
#line 1480 "parser_yacc.y"
              { /* nothing */ (yyval.fperms) = 0; }
#line 3718 "parser_yacc.c"
    break;

  case 173: /* ptrace_perms: ptrace_perms ptrace_perm  */
#line 1481 "parser_yacc.y"
                                   { (yyval.fperms) = (yyvsp[-1].fperms) | (yyvsp[0].fperms); }
#line 3724 "parser_yacc.c"
    break;

  case 174: /* ptrace_perms: ptrace_perms TOK_COMMA ptrace_perm  */
#line 1482 "parser_yacc.y"
                                             { (yyval.fperms) = (yyvsp[-2].fperms) | (yyvsp[0].fperms); }
#line 3730 "parser_yacc.c"
    break;

  case 175: /* opt_ptrace_perm: %empty  */
#line 1484 "parser_yacc.y"
                 { /* nothing */ (yyval.fperms) = 0; }
#line 3736 "parser_yacc.c"
    break;

  case 176: /* opt_ptrace_perm: ptrace_perm  */
#line 1485 "parser_yacc.y"
                      { (yyval.fperms) = (yyvsp[0].fperms); }
#line 3742 "parser_yacc.c"
    break;

  case 177: /* opt_ptrace_perm: TOK_OPENPAREN ptrace_perms TOK_CLOSEPAREN  */
#line 1486 "parser_yacc.y"
                                                    { (yyval.fperms) = (yyvsp[-1].fperms); }
#line 3748 "parser_yacc.c"
    break;

  case 178: /* ptrace_rule: TOK_PTRACE opt_ptrace_perm opt_conds TOK_END_OF_RULE  */
#line 1489 "parser_yacc.y"
        {
		ptrace_rule *ent = new ptrace_rule((yyvsp[-2].fperms), (yyvsp[-1].cond_entry));
		(yyval.ptrace_entry) = ent;
	}
#line 3757 "parser_yacc.c"
    break;

  case 179: /* userns_perm: TOK_VALUE  */
#line 1495 "parser_yacc.y"
        {
		if (strcmp((yyvsp[0].var_val), "create") == 0)
			(yyval.fperms) = AA_USERNS_CREATE;
		else
			(yyval.fperms) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3771 "parser_yacc.c"
    break;

  case 180: /* userns_perm: TOK_CREATE  */
#line 1504 "parser_yacc.y"
                     { (yyval.fperms) = AA_USERNS_CREATE; }
#line 3777 "parser_yacc.c"
    break;

  case 181: /* userns_perms: %empty  */
#line 1506 "parser_yacc.y"
              { /* nothing */ (yyval.fperms) = 0; }
#line 3783 "parser_yacc.c"
    break;

  case 182: /* userns_perms: userns_perms userns_perm  */
#line 1507 "parser_yacc.y"
                                   { (yyval.fperms) = (yyvsp[-1].fperms) | (yyvsp[0].fperms); }
#line 3789 "parser_yacc.c"
    break;

  case 183: /* userns_perms: userns_perms TOK_COMMA userns_perm  */
#line 1508 "parser_yacc.y"
                                             { (yyval.fperms) = (yyvsp[-2].fperms) | (yyvsp[0].fperms); }
#line 3795 "parser_yacc.c"
    break;

  case 184: /* opt_userns_perm: %empty  */
#line 1510 "parser_yacc.y"
                 { /* nothing */ (yyval.fperms) = 0; }
#line 3801 "parser_yacc.c"
    break;

  case 185: /* opt_userns_perm: userns_perm  */
#line 1511 "parser_yacc.y"
                      { (yyval.fperms) = (yyvsp[0].fperms); }
#line 3807 "parser_yacc.c"
    break;

  case 186: /* opt_userns_perm: TOK_OPENPAREN userns_perms TOK_CLOSEPAREN  */
#line 1512 "parser_yacc.y"
                                                    { (yyval.fperms) = (yyvsp[-1].fperms); }
#line 3813 "parser_yacc.c"
    break;

  case 187: /* userns_rule: TOK_USERNS opt_userns_perm opt_conds TOK_END_OF_RULE  */
#line 1515 "parser_yacc.y"
        {
		userns_rule *ent = new userns_rule((yyvsp[-2].fperms), (yyvsp[-1].cond_entry));
		(yyval.userns_entry) = ent;
	}
#line 3822 "parser_yacc.c"
    break;

  case 188: /* mqueue_perm: TOK_VALUE  */
#line 1521 "parser_yacc.y"
        {
		if (strcmp((yyvsp[0].var_val), "create") == 0)
			(yyval.fperms) = AA_MQUEUE_CREATE;
		else if (strcmp((yyvsp[0].var_val), "open") == 0)
			(yyval.fperms) = AA_MQUEUE_OPEN;
		else if (strcmp((yyvsp[0].var_val), "delete") == 0)
			(yyval.fperms) = AA_MQUEUE_DELETE;
		else if (strcmp((yyvsp[0].var_val), "getattr") == 0)
			(yyval.fperms) = AA_MQUEUE_GETATTR;
		else if (strcmp((yyvsp[0].var_val), "setattr") == 0)
			(yyval.fperms) = AA_MQUEUE_SETATTR;
		else if (strcmp((yyvsp[0].var_val), "write") == 0)
			(yyval.fperms) = AA_MQUEUE_WRITE;
		else if (strcmp((yyvsp[0].var_val), "read") == 0)
			(yyval.fperms) = AA_MQUEUE_READ;
		else if ((yyvsp[0].var_val)) {
			parse_mqueue_perms((yyvsp[0].var_val), &(yyval.fperms), 1);
		} else
			(yyval.fperms) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3850 "parser_yacc.c"
    break;

  case 189: /* mqueue_perm: TOK_CREATE  */
#line 1544 "parser_yacc.y"
                     { (yyval.fperms) = AA_MQUEUE_CREATE; }
#line 3856 "parser_yacc.c"
    break;

  case 190: /* mqueue_perm: TOK_OPEN  */
#line 1545 "parser_yacc.y"
                   { (yyval.fperms) = AA_MQUEUE_OPEN; }
#line 3862 "parser_yacc.c"
    break;

  case 191: /* mqueue_perm: TOK_DELETE  */
#line 1546 "parser_yacc.y"
                     { (yyval.fperms) = AA_MQUEUE_DELETE; }
#line 3868 "parser_yacc.c"
    break;

  case 192: /* mqueue_perm: TOK_GETATTR  */
#line 1547 "parser_yacc.y"
                      { (yyval.fperms) = AA_MQUEUE_GETATTR; }
#line 3874 "parser_yacc.c"
    break;

  case 193: /* mqueue_perm: TOK_SETATTR  */
#line 1548 "parser_yacc.y"
                      { (yyval.fperms) = AA_MQUEUE_SETATTR; }
#line 3880 "parser_yacc.c"
    break;

  case 194: /* mqueue_perm: TOK_WRITE  */
#line 1549 "parser_yacc.y"
                    { (yyval.fperms) = AA_MQUEUE_WRITE; }
#line 3886 "parser_yacc.c"
    break;

  case 195: /* mqueue_perm: TOK_READ  */
#line 1550 "parser_yacc.y"
                   { (yyval.fperms) = AA_MQUEUE_READ; }
#line 3892 "parser_yacc.c"
    break;

  case 196: /* mqueue_perm: TOK_MODE  */
#line 1552 "parser_yacc.y"
        {
		parse_mqueue_perms((yyvsp[0].mode), &(yyval.fperms), 1);
		free((yyvsp[0].mode));
	}
#line 3901 "parser_yacc.c"
    break;

  case 197: /* mqueue_perms: %empty  */
#line 1557 "parser_yacc.y"
              { /* nothing */ (yyval.fperms) = 0; }
#line 3907 "parser_yacc.c"
    break;

  case 198: /* mqueue_perms: mqueue_perms mqueue_perm  */
#line 1558 "parser_yacc.y"
                                   { (yyval.fperms) = (yyvsp[-1].fperms) | (yyvsp[0].fperms); }
#line 3913 "parser_yacc.c"
    break;

  case 199: /* mqueue_perms: mqueue_perms TOK_COMMA mqueue_perm  */
#line 1559 "parser_yacc.y"
                                             { (yyval.fperms) = (yyvsp[-2].fperms) | (yyvsp[0].fperms); }
#line 3919 "parser_yacc.c"
    break;

  case 200: /* opt_mqueue_perm: %empty  */
#line 1561 "parser_yacc.y"
                 { /* nothing */ (yyval.fperms) = 0; }
#line 3925 "parser_yacc.c"
    break;

  case 201: /* opt_mqueue_perm: mqueue_perm  */
#line 1562 "parser_yacc.y"
                      { (yyval.fperms) = (yyvsp[0].fperms); }
#line 3931 "parser_yacc.c"
    break;

  case 202: /* opt_mqueue_perm: TOK_OPENPAREN mqueue_perms TOK_CLOSEPAREN  */
#line 1563 "parser_yacc.y"
                                                    { (yyval.fperms) = (yyvsp[-1].fperms); }
#line 3937 "parser_yacc.c"
    break;

  case 203: /* mqueue_rule: TOK_MQUEUE opt_mqueue_perm opt_conds TOK_END_OF_RULE  */
#line 1566 "parser_yacc.y"
        {
		mqueue_rule *ent = new mqueue_rule((yyvsp[-2].fperms), (yyvsp[-1].cond_entry));
		(yyval.mqueue_entry) = ent;
	}
#line 3946 "parser_yacc.c"
    break;

  case 204: /* mqueue_rule: TOK_MQUEUE opt_mqueue_perm opt_conds TOK_ID TOK_END_OF_RULE  */
#line 1571 "parser_yacc.y"
        {
		mqueue_rule *ent = new mqueue_rule((yyvsp[-3].fperms), (yyvsp[-2].cond_entry), (yyvsp[-1].id));
		(yyval.mqueue_entry) = ent;
	}
#line 3955 "parser_yacc.c"
    break;

  case 205: /* io_uring_perm: TOK_VALUE  */
#line 1577 "parser_yacc.y"
        {
		if (strcmp((yyvsp[0].var_val), "override_creds") == 0)
			(yyval.fperms) = AA_IO_URING_OVERRIDE_CREDS;
		else if (strcmp((yyvsp[0].var_val), "sqpoll") == 0)
			(yyval.fperms) = AA_IO_URING_SQPOLL;
		else
			(yyval.fperms) = 0;

		if ((yyvsp[0].var_val))
			free((yyvsp[0].var_val));
	}
#line 3971 "parser_yacc.c"
    break;

  case 206: /* io_uring_perm: TOK_OVERRIDE_CREDS  */
#line 1588 "parser_yacc.y"
                             { (yyval.fperms) = AA_IO_URING_OVERRIDE_CREDS; }
#line 3977 "parser_yacc.c"
    break;

  case 207: /* io_uring_perm: TOK_SQPOLL  */
#line 1589 "parser_yacc.y"
                     { (yyval.fperms) = AA_IO_URING_SQPOLL; }
#line 3983 "parser_yacc.c"
    break;

  case 208: /* io_uring_perms: %empty  */
#line 1591 "parser_yacc.y"
                { /* nothing */ (yyval.fperms) = 0; }
#line 3989 "parser_yacc.c"
    break;

  case 209: /* io_uring_perms: io_uring_perms io_uring_perm  */
#line 1592 "parser_yacc.y"
                                       { (yyval.fperms) = (yyvsp[-1].fperms) | (yyvsp[0].fperms); }
#line 3995 "parser_yacc.c"
    break;

  case 210: /* io_uring_perms: io_uring_perms TOK_COMMA io_uring_perm  */
#line 1593 "parser_yacc.y"
                                                 { (yyval.fperms) = (yyvsp[-2].fperms) | (yyvsp[0].fperms); }
#line 4001 "parser_yacc.c"
    break;

  case 211: /* opt_io_uring_perm: %empty  */
#line 1595 "parser_yacc.y"
                   { /* nothing */ (yyval.fperms) = 0; }
#line 4007 "parser_yacc.c"
    break;

  case 212: /* opt_io_uring_perm: io_uring_perm  */
#line 1596 "parser_yacc.y"
                        { (yyval.fperms) = (yyvsp[0].fperms); }
#line 4013 "parser_yacc.c"
    break;

  case 213: /* opt_io_uring_perm: TOK_OPENPAREN io_uring_perms TOK_CLOSEPAREN  */
#line 1597 "parser_yacc.y"
                                                      { (yyval.fperms) = (yyvsp[-1].fperms); }
#line 4019 "parser_yacc.c"
    break;

  case 214: /* io_uring_rule: TOK_IO_URING opt_io_uring_perm opt_conds opt_cond_list TOK_END_OF_RULE  */
#line 1600 "parser_yacc.y"
        {
		io_uring_rule *ent;
		ent = new io_uring_rule((yyvsp[-3].fperms), (yyvsp[-2].cond_entry), (yyvsp[-1].cond_entry_list).list);
		if (!ent)
			yyerror(_("Memory allocation error."));
		(yyval.io_uring_entry) = ent;
	}
#line 4031 "parser_yacc.c"
    break;

  case 215: /* hat_start: TOK_CARET  */
#line 1608 "parser_yacc.y"
                     {}
#line 4037 "parser_yacc.c"
    break;

  case 216: /* hat_start: TOK_HAT  */
#line 1609 "parser_yacc.y"
                  {}
#line 4043 "parser_yacc.c"
    break;

  case 217: /* file_perms: TOK_MODE  */
#line 1612 "parser_yacc.y"
        {
		/* A single TOK_MODE maps to the same permission in all
		 * of user::other */
		(yyval.fperms) = parse_perms((yyvsp[0].mode));
		free((yyvsp[0].mode));
	}
#line 4054 "parser_yacc.c"
    break;

  case 218: /* change_profile: TOK_CHANGE_PROFILE opt_exec_mode opt_id opt_named_transition TOK_END_OF_RULE  */
#line 1620 "parser_yacc.y"
        {
		struct cod_entry *entry;
		perms_t perms = AA_CHANGE_PROFILE;
		int exec_mode = (yyvsp[-3].boolean);
		char *exec = (yyvsp[-2].id);
		char *target = (yyvsp[-1].id);

		if (exec) {
			/* exec bits required to trigger rule conflict if
			 * for overlapping safe and unsafe exec rules
			 */
			perms |= AA_EXEC_BITS;
			if (exec_mode == EXEC_MODE_UNSAFE)
				perms |= ALL_AA_EXEC_UNSAFE;
			else if (exec_mode == EXEC_MODE_SAFE &&
				 !features_supports_stacking) {
				pwarn(WARN_RULE_DOWNGRADED, "downgrading change_profile safe rule to unsafe due to lack of necessary kernel support\n");
				/**
				 * No need to do anything because 'unsafe' exec
				 * mode is the only supported mode of
				 * change_profile rules in non-stacking kernels
				 */
			}
		} else if (exec_mode != EXEC_MODE_EMPTY)
			yyerror(_("Exec condition is required when unsafe or safe keywords are present"));
		if (exec && !(exec[0] == '/' || strncmp(exec, "@{", 2) == 0))
			yyerror(_("Exec condition must begin with '/'."));

		if (target) {
			PDEBUG("Matched change_profile: tok_id (%s)\n", target);
		} else {
			PDEBUG("Matched change_profile,\n");
			target = strdup("**");
			if (!target)
				yyerror(_("Memory allocation error."));
		}

		entry = new_entry(target, perms, exec);
		if (!entry)
			yyerror(_("Memory allocation error."));

		PDEBUG("change_profile.entry: (%s)\n", entry->name);
		(yyval.user_entry) = entry;
	}
#line 4103 "parser_yacc.c"
    break;

  case 219: /* capability: TOK_CAPABILITY caps TOK_END_OF_RULE  */
#line 1666 "parser_yacc.y"
        {
		if ((yyvsp[-1].cap) == 0) {
			/* bare capability keyword - set all caps */
			(yyval.cap) = 0xffffffffffffffff;
		} else
			(yyval.cap) = (yyvsp[-1].cap);
	}
#line 4115 "parser_yacc.c"
    break;

  case 220: /* caps: %empty  */
#line 1674 "parser_yacc.y"
      { /* nothing */ (yyval.cap) = 0; }
#line 4121 "parser_yacc.c"
    break;

  case 221: /* caps: caps TOK_ID  */
#line 1676 "parser_yacc.y"
        {
		int backmap, cap = name_to_capability((yyvsp[0].id));
		if (cap == -1)
			yyerror(_("Invalid capability %s."), (yyvsp[0].id));
		free((yyvsp[0].id));
		backmap = capability_backmap(cap);
		if (backmap != NO_BACKMAP_CAP && !capability_in_kernel(cap)) {
			/* TODO: special backmap warning */
			cap = backmap;
		}
		(yyval.cap) = (yyvsp[-1].cap) | CAP_TO_MASK(cap);
	}
#line 4138 "parser_yacc.c"
    break;


#line 4142 "parser_yacc.c"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 1689 "parser_yacc.y"

#define MAXBUFSIZE 4096

void vprintyyerror(const char *msg, va_list argptr)
{
	char buf[MAXBUFSIZE];

	vsnprintf(buf, sizeof(buf), msg, argptr);

	if (profilename) {
		PERROR(_("AppArmor parser error for %s%s%s at line %d: %s\n"),
		       profilename,
		       current_filename ? " in profile " : "",
		       current_filename ? current_filename : "",
		       current_lineno, buf);
	} else {
		PERROR(_("AppArmor parser error at line %d: %s\n"),
		       current_lineno, buf);
	}
}

void printyyerror(const char *msg, ...)
{
	va_list arg;

	va_start(arg, msg);
	vprintyyerror(msg, arg);
	va_end(arg);
}

void yyerror(const char *msg, ...)
{
	va_list arg;

	va_start(arg, msg);
	vprintyyerror(msg, arg);
	va_end(arg);

	exit(1);
}

struct cod_entry *do_file_rule(char *id, perms_t perms, char *link_id, char *nt)
{
		struct cod_entry *entry;
		PDEBUG("Matched: tok_id (%s) tok_perms (0x%x)\n", id, perms);
		entry = new_entry(id, perms, link_id);
		if (!entry)
			yyerror(_("Memory allocation error."));
		entry->nt_name = nt;
		PDEBUG("rule.entry: (%s)\n", entry->name);
		return entry;
}

static const char *mnt_cond_msg[] = {"",
			 " not allowed as source conditional",
			 " not allowed as target conditional",
			 "",
			 NULL};

int verify_mnt_conds(struct cond_entry *conds, int src)
{
	struct cond_entry *entry;
	int error = 0;

	if (!conds)
		return 0;

	list_for_each(conds, entry) {
		int res = is_valid_mnt_cond(entry->name, src);
		if (res <= 0) {
				printyyerror(_("invalid mount conditional %s%s"),
					     entry->name,
					     res == -1 ? "" : mnt_cond_msg[src]);
				error++;
		}
	}

	return error;
}

mnt_rule *do_mnt_rule(struct cond_entry *src_conds, char *src,
		      struct cond_entry *dst_conds, char *dst,
		      perms_t perms)
{
	if (verify_mnt_conds(src_conds, MNT_SRC_OPT) != 0)
		yyerror(_("bad mount rule"));

	/* FIXME: atm conditions are not supported on dst
	if (verify_conds(dst_conds, DST_OPT) != 0)
		yyerror(_("bad mount rule"));
	*/
	if (dst_conds)
		yyerror(_("mount point conditions not currently supported"));

	mnt_rule *ent = new mnt_rule(src_conds, src, dst_conds, dst, perms);
	if (!ent) {
		yyerror(_("Memory allocation error."));
	}

	return ent;
}

mnt_rule *do_pivot_rule(struct cond_entry *old, char *root, char *transition)
{
	char *device = NULL;
	if (old) {
		if (strcmp(old->name, "oldroot") != 0)
			yyerror(_("invalid pivotroot conditional '%s'"), old->name);
		if (old->vals) {
			device = old->vals->value;
			old->vals->value = NULL;
		}
		free_cond_entry(old);
	}

	mnt_rule *ent = new mnt_rule(NULL, device, NULL, root, AA_MAY_PIVOTROOT);
	ent->trans = transition;

	return ent;
}

static int abi_features_base(struct aa_features **features, char *filename, bool search)
{
	autofclose FILE *f = NULL;
	struct stat my_stat;
	autofree char *fullpath = NULL;
	bool cached;

	if (search) {
		if (strcmp(filename, "kernel") == 0)
			return aa_features_new_from_kernel(features);
		f = search_path(filename, &fullpath, &cached);
		PDEBUG("abi lookup '%s' -> '%s' f %p cached %d\n", filename, fullpath, f, cached);
		if (!f && cached) {
			*features = NULL;
			return 0;
		}
	} else {
		f = fopen(filename, "r");
		PDEBUG("abi relpath '%s' f %p\n", filename, f);
	}

	if (!f) {
		yyerror(_("Could not open '%s': %m"),
                        fullpath ? fullpath: filename);
	}

	if (fstat(fileno(f), &my_stat))
		yyerror(_("fstat failed for '%s': %m"), fullpath ? fullpath : filename);

        if (S_ISREG(my_stat.st_mode)) {
		return aa_features_new_from_file(features, fileno(f));
	}

	return -1;
}

static void abi_features(char *filename, bool search)
{
	struct aa_features *tmp_features;

	if (abi_features_base(&tmp_features, filename, search) == -1) {
			yyerror(_("failed to find features abi '%s': %m"), filename);
	}
	if (policy_features) {
		if (tmp_features) {
			if (!aa_features_is_equal(tmp_features, policy_features)) {
				pwarn(WARN_ABI, _("%s: %s features abi '%s' differs from policy declared feature abi, using the features abi declared in policy\n"), progname, current_filename, filename);
			}
			aa_features_unref(tmp_features);
		}
	} else if (!tmp_features) {
		/* skipped reinclude, but features not set */
		yyerror(_("failed features abi not set but include cache skipped\n"));
	} else {
		/* first features abi declaration */
		policy_features = tmp_features;
	}

};

bool check_x_qualifier(struct cod_entry *entry, const char *&error)
{
	if (entry->perms & AA_EXEC_BITS) {
		if ((entry->rule_mode == RULE_DENY) &&
		    (entry->perms & ALL_AA_EXEC_TYPE)) {
			error = _("Invalid perms, in deny rules 'x' must not be preceded by exec qualifier 'i', 'p', or 'u'");
			return false;
		} else if ((entry->rule_mode != RULE_DENY) &&
			   !(entry->perms & ALL_AA_EXEC_TYPE)) {
			error = _("Invalid perms, 'x' must be preceded by exec qualifier 'i', 'p', or 'u'");
			return false;
		}
	}
	return true;
}

// cod_entry version of ->add_prefix here just as file rules aren't converted yet
bool add_prefix(struct cod_entry *entry, const prefixes &p, const char *&error)
{
	/* modifiers aren't correctly stored for cod_entries yet so
	 * we can't conflict on them easily. Leave that until conversion
	 * to rule_t
	 */
	/* apply rule mode */
	entry->rule_mode = p.rule_mode;

	/* apply owner/other */
	if (p.owner == 1)
		entry->perms &= (AA_USER_PERMS | AA_SHARED_PERMS);
	else if (p.owner == 2)
		entry->perms &= (AA_OTHER_PERMS | AA_SHARED_PERMS);

	/* implied audit modifier */
	if (p.audit == AUDIT_FORCE && (entry->rule_mode != RULE_DENY))
		entry->audit = AUDIT_FORCE;
	else if (p.audit != AUDIT_FORCE && (entry->rule_mode == RULE_DENY))
		entry->audit = AUDIT_FORCE;

	return check_x_qualifier(entry, error);
}
